=== modified file 'MANIFEST.in'
--- MANIFEST.in	2008-06-22 18:04:15 +0000
+++ MANIFEST.in	2007-03-26 06:08:50 +0000
@@ -1,2 +1,4 @@
-include loggerhead.conf.example README.txt NEWS
+include dev.cfg loggerhead.conf.example README.txt NEWS
+recursive-include loggerhead/templates *.kid
+recursive-include loggerhead/config *.cfg
 recursive-include loggerhead/static *

=== modified file 'NEWS'
--- NEWS	2008-06-22 23:47:59 +0000
+++ NEWS	2008-03-06 01:59:26 +0000
@@ -1,48 +1,6 @@
 What's changed in loggerhead?
 =============================
 
-1.6 [unreleased]
-----------------
-
-    - Loggerhead is no longer a TurboGears application, but rather a
-      WSGI application built using Paste (see http://wsgi.org/ and
-      http://pythonpaste.org/ for more about WSGI and Paste). XXX more.
-
-    - zpt.cleaner_urls bug 138021 ("loggerhead should generate links
-      based on revision numbers and file paths").  XXX more.
-
-    - The scripts no longer insist on Python 2.4 -- loggerhead works
-      fine with 2.5.
-
-    - Bazaar as of version 1.5 has improved in performance enough that
-      the revision cache no longer gave any noticeable benefit, so it
-      was removed (the files-changed cache is still useful).
-
-    - The templates were rewritten in Zope's TAL markup, powered by
-      the simpleTAL library -- improving both the performance and
-      memory consumption of rendering by a factor of around 3 for
-      large pages over the old Kid templates.
-
-    - Loggerhead's poorly performing text index was disabled.
-
-    - Loggerhead no longer depends on bzrlib functions deprecated in
-      Bazaar 1.5 and removed in 1.6 (Martin Albisetti).
-
-    - The daemonization code was made more regular, fixing bugs
-      #139161 ("Starting loggerhead process may not close its stdin
-      and stdout properly") and #211526 ("Codebrowse log directory has
-      unnecessarily permissive permissions")
-
-    - Some confusion about what the 'file_id' query argument means was
-      cleared up: filter_file_id now means "filter revisions to those
-      that affect this file" in all views and file_id means "examine
-      this file/directory" in the annotate and inventory views.
-
-    - Dates are present more compactly.
-
-    - The loggerhead.conf file can specify which network interface to
-      bind to (Mattias Eriksson)
-
 1.2.1  [06mar2008]
 ------------------
 

=== modified file 'README.txt'
--- README.txt	2008-06-23 02:37:05 +0000
+++ README.txt	2008-03-03 23:10:35 +0000
@@ -1,69 +1,29 @@
 LOGGERHEAD
 ==========
 
-[ Version 1.6 for Bazaar 1.6 ]
+[ Version 1.2 for Bazaar 1.2 ]
 
 Loggerhead is a web viewer for Bazaar branches.  It can be used to
 navigate a branch history, annotate files, perform searches... all the
 usual things.
 
-
-GETTING STARTED
----------------
-
-Loggerhead depends on SimpleTAL for templating and Paste for the
-server.  So you need these installed -- on Ubuntu you want the
-'python-simpletal' and 'python-paste' packages installed.  You need
-version 1.2 or newer of Paste.
-
-Then simply run the 'serve-branches.py' with the branch you want to
-serve on the command line:
-
-    ./serve-branches.py ~/path/to/branch
-
-The script listens on port 8080 so head to http://localhost:8080/ in
-your browser to see the branch.  You can also pass a directory that
-contains branches to the script, and it will serve a very simple
-directory listing at other pages.
-
-You may update the Bazaar branches being viewed at any time.
-Loggerhead will notice and refresh, and Bazaar uses its own branch
-locking to prevent corruption.
-
-
-USING A CONFIG FILE
--------------------
-
-Previous versions of Loggerhead read their configuration from a config
-file.  This mode of operation is still supported by the
-'start-loggerhead.py' script.  A 'loggerhead.conf.example' file is
-included in the source which has comments explaining the various
-options.
+To get started, first you need to create a 'loggerhead.conf' file
+specifying the branches you want to view.  A 'loggerhead.conf.example'
+file is included in the source which has comments explaining the
+various options.
 
 Loggerhead can then be started by running::
 
     $ ./start-loggerhead.py
 
-This will run loggerhead in the background, listening on port 8080 by
-default.
+This will run loggerhead in the background.  It listens on port 8080
+by default, so go to http://localhost:8080/ in your browser to see the
+list of bublished branches.
 
 To stop Loggerhead, run::
 
     $ ./stop-loggerhead.py
 
-In the configuration file you can configure projects, and branches per
-project.  The idea is that you could be publishing several (possibly
-unrelated) projects through the same loggerhead instance, and several
-branches for the same project.  See the "loggerhead.conf.example" file
-included with the source.
-
-A debug and access log are stored in the logs/ folder, relative to
-the location of the start-loggerhead.py script.
-
-
-SERVING LOGGERHEAD FROM BEHIND APACHE
--------------------------------------
-
 If you want to view Bazaar branches from your existing Apache
 installation, you'll need to configure Apache to proxy certain
 requests to Loggerhead.  Adding lines like this to you Apache
@@ -74,19 +34,41 @@
         ProxyPassReverse http://127.0.0.1:8080/
     </Location>
 
-If Paste Deploy is installed, the 'serve-branches.py' script can be
-run behind a proxy at the root of a site, but if you're running it at
-some path into the site, you'll need to add a 'prefix' argument to the
-PrefixMiddleware call in the script.  More flexible configuration
-should be added soon...
-
-
-FILES CHANGED CACHE
--------------------
-
-To speed up the display of the changelog view for large trees,
-loggerhead can be configured to cache the files changes between
-revisions.  Set the 'cachepath' value in the config file.
+In the configuration file you can configure projects, and branches per
+project.  The idea is that you could be publishing several (possibly
+unrelated) projects through the same loggerhead instance, and several
+branches for the same project.  See the "loggerhead.conf.example" file
+included with the source.
+
+Although Loggerhead is a TurboGears (http://www.turbogears.org)
+project, don't bother with "dev.cfg" or any of the other TurboGears
+config files.  Loggerhead overrides those values with its own.
+
+A debug and access log are stored in the logs/ folder, relative to
+the location of the start-loggerhead.py script.
+
+You may update the Bazaar branch at any time (for example, from a cron).
+Loggerhead will notice and refresh, and Bazaar uses its own branch
+locking to prevent corruption.
+
+
+CACHES
+------
+
+To speed up operations with large branches, loggerhead can be configured
+to create three caches per branch when it first launches:
+
+    - a revision data cache
+    - a cache of files changed in a revision
+    - a text searching cache
+
+You can put the cache folder anywhere.
+
+The revision data cache and text searching cache will be automatically
+filled once loggerhead starts up.  The caches for a branch with 15,000
+revisions take about four minutes each on a fairly fast machine, but
+mileage may vary.  Once they are built, they update every six hours or
+so but usually finish quickly (or instantly) after the initial creation.
 
 
 SUPPORT
@@ -99,6 +81,3 @@
 subscribe to post, but your first post will be held briefly for manual
 moderation.
 
-Bugs are tracked on Launchpad; start at:
-
-    https://bugs.launchpad.net/loggerhead

=== added file 'dev.cfg'
--- dev.cfg	1970-01-01 00:00:00 +0000
+++ dev.cfg	2007-12-12 08:36:51 +0000
@@ -0,0 +1,77 @@
+[global]
+# This is where all of your settings go for your development environment
+# Settings that are the same for both development and production
+# (such as template engine, encodings, etc.) all go in 
+# loggerhead/config/app.cfg
+
+# DATABASE
+
+# pick the form for your database
+# sqlobject.dburi="postgres://username@hostname/databasename"
+# sqlobject.dburi="mysql://username:password@hostname:port/databasename"
+# sqlobject.dburi="sqlite:///file_name_and_path"
+
+# If you have sqlite, here's a simple default to get you started
+# in development
+sqlobject.dburi="sqlite://%(current_dir_uri)s/devdata.sqlite"
+
+
+# if you are using a database or table type without transactions
+# (MySQL default, for example), you should turn off transactions
+# by prepending notrans_ on the uri
+# sqlobject.dburi="notrans_mysql://username:password@hostname:port/databasename"
+
+# for Windows users, sqlite URIs look like:
+# sqlobject.dburi="sqlite:///drive_letter:/path/to/file"
+
+# SERVER
+
+# Some server parameters that you may want to tweak
+# server.socket_port=8080
+
+# Enable the debug output at the end on pages.
+# log_debug_info_filter.on = False
+
+#server.environment="development"
+server.environment="production"
+#autoreload.package="loggerhead"
+
+# We do *not* want our query arguments turned into unicode strings (as
+# we use them for revision/file ids, and these must not be unicode).
+decoding_filter.on = False
+
+# session_filter.on = True
+
+# Set to True if you'd like to abort execution if a controller gets an
+# unexpected parameter. False by default
+tg.strict_parameters = True
+
+# turn on timer scheduling
+tg.scheduler = True
+
+# LOGGING
+# Logging configuration generally follows the style of the standard
+# Python logging module configuration. Note that when specifying
+# log format messages, you need to use *() for formatting variables.
+# Deployment independent log configuration is in loggerhead/config/log.cfg
+[logging]
+
+[[loggers]]
+[[[loggerhead]]]
+level='DEBUG'
+#qualname='loggerhead'
+#handlers=['debug_out']
+
+#[[[allinfo]]]
+#level='INFO'
+#handlers=['debug_out']
+
+[[[access]]]
+level='INFO'
+qualname='turbogears.access'
+#handlers=['access_out']
+#propagate=0
+
+
+
+

=== added directory 'homepage'
=== added directory 'homepage/download'
=== added file 'homepage/download/loggerhead-1.0-0.13.tar.gz'
Binary files homepage/download/loggerhead-1.0-0.13.tar.gz and homepage/download/loggerhead-1.0-0.13.tar.gz differ
=== added file 'homepage/download/loggerhead-1.1-0.13.tar.gz'
Binary files homepage/download/loggerhead-1.1-0.13.tar.gz and homepage/download/loggerhead-1.1-0.13.tar.gz differ
=== added file 'homepage/download/loggerhead-1.1.1-0.13.tar.gz'
Binary files homepage/download/loggerhead-1.1.1-0.13.tar.gz and homepage/download/loggerhead-1.1.1-0.13.tar.gz differ
=== added file 'homepage/index.html'
--- homepage/index.html	1970-01-01 00:00:00 +0000
+++ homepage/index.html	2007-01-24 23:39:39 +0000
@@ -0,0 +1,74 @@
+<html>
+<head>
+    <style type="text/css">
+@import "loggerhead.css";
+    </style>
+</head>
+<body>
+    <img src="loggerhead-logo-medium.png" />
+    
+    <p>
+    Loggerhead is a web viewer for projects in
+    <a href="http://www.bazaar-vcs.org/">bazaar</a>.
+    It can be used to navigate
+    a branch history, annotate files, view patches, perform searches, etc.
+    It's heavily based on 
+    <a href="https://launchpad.net/products/bzr-webserve">bazaar-webserve</a>,
+    which is itself based on
+    <a href="http://www.selenic.com/mercurial/wiki/index.cgi">hgweb</a> for
+    Mercurial.  The primary difference is that loggerhead is built on top of
+    <a href="http://www.turbogears.org/">TurboGears</a>.
+    </p>
+    
+    <p>
+    Loggerhead is released under the GPL license, and is written entirely
+    in python 2.4.
+    </p>
+    
+    <h2> News </h2>
+    
+    <ul>
+    <li> <span class="date"> 24 Jan 2007 </span> <br>
+        Loggerhead 1.1.1 released, to fix a paper-bag bug and a couple of
+        rendering quirks. </li>
+    <li> <span class="date"> 20 Jan 2007 </span> <br>
+        Loggerhead 1.1 released, with a lot of new features and improvements.
+        </li>
+    </ul>
+    
+    <h2> Download </h2>
+    
+    <p>
+    The current version is 1.1.1-0.13 (meaning 1.1.1, requiring bazaar 0.13),
+    released on 24 Jan 2006 at revision 109.
+    </p>
+    <ul class="downloads">
+    <li> <a href="download/loggerhead-1.1.1-0.13.tar.gz"> loggerhead-1.1.1-0.13.tar.gz </a>
+        <br /> <span class="md5"> MD5: 288af4396620443b7f2acd96a62ffbbf </span>
+        </li>
+    <li> <a href="download/loggerhead-1.1-0.13.tar.gz"> loggerhead-1.1-0.13.tar.gz </a>
+        <br /> <span class="md5"> MD5: 26194d00c72dbcaf63d14d9d099ee91e </span>
+        </li>
+    <li> <a href="download/loggerhead-1.0-0.13.tar.gz"> loggerhead-1.0-0.13.tar.gz </a>
+        <br /> <span class="md5"> MD5: 1b68c1dc6e13f9ed8f2b3ff0267cd8d9 </span>
+        </li>
+    </ul>
+    
+    <h2> Development </h2>
+    
+    <ul>
+    <li> project page on launchpad (for bug reports): <br />
+    <a class="link" href="https://launchpad.net/products/loggerhead/"> https://launchpad.net/products/loggerhead/ </a>
+    </li>
+
+    <li> development branch in bazaar: <br />
+    <a class="link" href="http://www.lag.net/robey/code/loggerhead/"> http://www.lag.net/robey/code/loggerhead/ </a>
+    </li>
+
+    <li> browse the source in loggerview: <br />
+    <a class="link" href="http://www.lag.net/branches/loggerhead/loggerhead_dev/"> http://www.lag.net/branches/loggerhead/loggerhead_dev/ </a>
+    </li>
+    </ul>	
+    
+</body>
+</html>

=== added file 'homepage/loggerhead-background.png'
Binary files homepage/loggerhead-background.png and homepage/loggerhead-background.png differ
=== added file 'homepage/loggerhead-logo-medium.png'
Binary files homepage/loggerhead-logo-medium.png and homepage/loggerhead-logo-medium.png differ
=== added file 'homepage/loggerhead.css'
--- homepage/loggerhead.css	1970-01-01 00:00:00 +0000
+++ homepage/loggerhead.css	2007-01-24 23:39:39 +0000
@@ -0,0 +1,50 @@
+body {
+    background: url("loggerhead-background.png"); 
+    margin: 0px;
+    font-family: "Lucida Grande", Helvetica;
+    line-height: 1.4em;
+}
+img {
+    border: none;
+}
+p,ul {
+    margin-left: 2em;
+    width: 70%;
+}
+
+a {
+    text-decoration: none;
+    color: #204c90;
+}
+a:hover {
+    text-decoration: underline;
+}
+
+h2 {
+    font-size: 100%;
+    margin-left: 2em;
+    margin-right: 2em;
+    margin-top: 1.5em;
+    border-bottom: solid 1px black;
+}
+
+ul {
+    list-style: url(sphere.png);
+}
+ul.downloads .md5 {
+    font-family: monospace;
+    margin-left: 2em;
+}
+li {
+	margin-bottom: 1em;
+}
+
+.link {
+	margin-left: 1em;
+}
+
+.date {
+    font-weight: bold;
+    font-size: smaller;
+    text-decoration: underline;
+}

=== added file 'homepage/sphere.png'
Binary files homepage/sphere.png and homepage/sphere.png differ
=== modified file 'loggerhead.conf.example'
--- loggerhead.conf.example	2008-06-16 09:48:20 +0000
+++ loggerhead.conf.example	2008-03-06 07:30:37 +0000
@@ -27,8 +27,8 @@
     # for the top browsing page, you can include a description, in raw HTML.
     #description = 'Bazaar is a <i>revision control system</i>.'
 
-    # should we cache files changed? (recommended for large trees)
-    # this will be a folder containing one file.  if the folder doesn't
+    # should we cache revisions and build a text index?  (HIGHLY recommended)
+    # this will be a folder containing a few files.  if the folder doesn't
     # exist, it'll be created.
     #
     # all branches in this project will share the same cache, which is usually

=== modified file 'loggerhead/__init__.py'
--- loggerhead/__init__.py	2008-06-18 06:34:10 +0000
+++ loggerhead/__init__.py	2008-06-10 22:44:49 +0000
@@ -0,0 +1,2 @@
+# Register the 'zpt' template handler:
+import turbosimpletal

=== removed directory 'loggerhead/apps'
=== removed file 'loggerhead/apps/__init__.py'
--- loggerhead/apps/__init__.py	2008-07-01 04:01:31 +0000
+++ loggerhead/apps/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,12 +0,0 @@
-"""WSGI applications for serving Bazaar branches."""
-
-import os
-
-from paste import urlparser, fileapp
-
-static = os.path.join(
-    os.path.dirname(os.path.dirname(__file__)), 'static')
-
-static_app = urlparser.make_static(None, static)
-
-favicon_app = fileapp.FileApp(os.path.join(static, 'images', 'favicon.ico'))

=== removed file 'loggerhead/apps/config.py'
--- loggerhead/apps/config.py	2008-07-01 04:01:31 +0000
+++ loggerhead/apps/config.py	1970-01-01 00:00:00 +0000
@@ -1,219 +0,0 @@
-"""A server that uses a loggerhead.conf file.
-
-We recreate the branch discovery and url scheme of the old branchview
-code.  It's all a bit horrible really.
-"""
-
-import logging
-import os
-import posixpath
-
-import bzrlib.lru_cache
-
-from configobj import ConfigObj
-
-from paste.request import path_info_pop
-from paste import httpexceptions
-from paste.wsgiwrappers import WSGIResponse
-
-from loggerhead.apps.branch import BranchWSGIApp
-from loggerhead.apps import favicon_app, static_app
-from loggerhead.templatefunctions import templatefunctions
-from loggerhead.zptsupport import load_template
-from loggerhead import util
-
-log = logging.getLogger("loggerhead.controllers")
-
-from loggerhead.history import is_branch
-
-class Project(object):
-    """A project contains the branches.
-
-    There is some complication because we don't want to hold on to the
-    branches when they are not being browsed."""
-
-    def __init__(self, name, config, root_config, graph_cache):
-        self.name = name
-        self.friendly_name = config.get('name', name)
-        self.description = config.get('description', '')
-        self.long_description = config.get('long_description', '')
-        self._config = config
-        self._root_config = root_config
-        self.graph_cache = graph_cache
-
-        self.view_names = []
-        self.view_data_by_name = {}
-        for view_name in config.sections:
-            log.debug('Configuring (project %s) branch %s...', name, view_name)
-            self._add_view(
-                view_name, config[view_name], config[view_name].get('folder'))
-
-        self._auto_folder = config.get('auto_publish_folder', None)
-        self._auto_list = []
-        if self._auto_folder is not None:
-            self._recheck_auto_folders()
-
-    def _recheck_auto_folders(self):
-        if self._auto_folder is None:
-            return
-        auto_list = []
-        # scan a folder for bazaar branches, and add them automatically
-        for path, folders, filenames in os.walk(self._auto_folder):
-            for folder in folders:
-                folder = os.path.join(path, folder)
-                if is_branch(folder):
-                    auto_list.append(folder)
-        auto_list.sort()
-        if auto_list == self._auto_list:
-            # nothing has changed; do nothing.
-            return
-
-        # rebuild views:
-        self.view_names = []
-        log.debug('Rescanning auto-folder for project %s ...', self.name)
-        for folder in auto_list:
-            view_name = os.path.basename(folder)
-            log.debug('Auto-configuring (project %s) branch %s...', self.name, view_name)
-            self._add_view(view_name, ConfigObj(), folder)
-        self._auto_list = auto_list
-
-    def _get_branch_url(self, view, view_config, folder):
-        url = view_config.get('url', None)
-        if url is not None:
-            return url
-        url = self._config.get('url_prefix', None)
-        if url is not None:
-            return posixpath.join(url, folder) + '/'
-        return None
-
-    def _get_description(self, view, view_config, history):
-        description = view_config.get('description', None)
-        if description is not None:
-            return description
-        description = history._branch.get_config().get_user_option('description')
-        return description
-
-    def _add_view(self, view_name, view_config, folder):
-        b = bzrlib.branch.Branch.open(folder)
-        view = BranchWSGIApp(b, view_name, view_config, self.graph_cache)
-        b.lock_read()
-        try:
-            history = view.get_history()
-            friendly_name = view_config.get('branch_name', None)
-            if friendly_name is None:
-                friendly_name = history.get_config().get_nickname()
-                if friendly_name is None:
-                    friendly_name = view_name
-            self.view_data_by_name[view_name] = {
-                'branch_path': folder,
-                'args': (view_name, view_config, self.graph_cache),
-                'description': self._get_description(view, view_config, history),
-                '_src_folder': folder,
-                '_view_config': view_config,
-                'friendly_name': friendly_name,
-                'name': view_name,
-                }
-            branch_url = self._get_branch_url(view, view_config, view_name)
-            if branch_url is not None:
-                self.view_data_by_name[view_name]['branch_url'] = branch_url
-            self.view_names.append(view_name)
-        finally:
-            b.unlock()
-
-    def view_named(self, name):
-        view_data = self.view_data_by_name.get(name)
-        if view_data is None:
-            return None
-        view_data = view_data.copy()
-        branch_path = view_data.pop('branch_path')
-        args = view_data.pop('args')
-        b = bzrlib.branch.Branch.open(branch_path)
-        b.lock_read()
-        view = BranchWSGIApp(b, *args)
-        for k in view_data:
-            setattr(view, k, view_data[k])
-        return view
-
-    def call(self, environ, start_response):
-        segment = path_info_pop(environ)
-        if not segment:
-            raise httpexceptions.HTTPNotFound()
-        else:
-            view = self.view_named(segment)
-            if view is None:
-                raise httpexceptions.HTTPNotFound()
-            try:
-                return view.app(environ, start_response)
-            finally:
-                view.branch.unlock()
-
-
-class Root(object):
-    """The root of the server -- renders as the browse view,
-    dispatches to Project above for each 'project'."""
-
-    def __init__(self, config):
-        self.projects = []
-        self.config = config
-        self.projects_by_name = {}
-        graph_cache = bzrlib.lru_cache.LRUCache()
-        for project_name in self.config.sections:
-            project = Project(
-                project_name, self.config[project_name], self.config, graph_cache)
-            self.projects.append(project)
-            self.projects_by_name[project_name] = project
-
-    def browse(self, response):
-        # This is insanely complicated because we want to open and
-        # lock all the branches, render the view and then unlock the
-        # branches again.
-        for p in self.projects:
-            p._recheck_auto_folders()
-        class branch(object):
-            @staticmethod
-            def static_url(path):
-                return self._static_url_base + path
-        views_by_project = {}
-        all_views = []
-        try:
-            for p in self.projects:
-                views_by_project[p] = []
-                for vn in p.view_names:
-                    v = p.view_named(vn)
-                    all_views.append(v)
-                    views_by_project[p].append(v)
-            vals = {
-                'projects': self.projects,
-                'util': util,
-                'title': self.config.get('title', None),
-                'branch': branch,
-                'views_by_project': views_by_project,
-            }
-            vals.update(templatefunctions)
-            response.headers['Content-Type'] = 'text/html'
-            template = load_template('loggerhead.templates.browse')
-            template.expand_into(response, **vals)
-        finally:
-            for v in all_views:
-                v.branch.unlock()
-
-    def __call__(self, environ, start_response):
-        self._static_url_base = environ['loggerhead.static.url'] = \
-                                environ['SCRIPT_NAME']
-        segment = path_info_pop(environ)
-        if segment is None:
-            raise httpexceptions.HTTPMovedPermanently(
-                environ['SCRIPT_NAME'] + '/')
-        elif segment == '':
-            response = WSGIResponse()
-            self.browse(response)
-            return response(environ, start_response)
-        elif segment == 'static':
-            return static_app(environ, start_response)
-        elif segment == 'favicon.ico':
-            return favicon_app(environ, start_response)
-        else:
-            project = self.projects_by_name.get(segment)
-            if project is None:
-                raise httpexceptions.HTTPNotFound()
-            return project.call(environ, start_response)

=== added file 'loggerhead/branchview.py'
--- loggerhead/branchview.py	1970-01-01 00:00:00 +0000
+++ loggerhead/branchview.py	2008-04-18 00:33:19 +0000
@@ -0,0 +1,185 @@
+#
+# Copyright (C) 2006  Robey Pointer <robey@lag.net>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+"""
+collection of configuration and objects related to a bazaar branch.
+"""
+
+import logging
+import posixpath
+import threading
+import urllib
+
+import turbogears
+from cherrypy import HTTPRedirect
+
+from loggerhead import util
+from loggerhead.changecache import ChangeCache, FileChangeCache
+from loggerhead.history import History
+from loggerhead.textindex import TextIndex
+from loggerhead.controllers.changelog_ui import ChangeLogUI
+from loggerhead.controllers.atom_ui import AtomUI
+from loggerhead.controllers.revision_ui import RevisionUI
+from loggerhead.controllers.inventory_ui import InventoryUI
+from loggerhead.controllers.annotate_ui import AnnotateUI
+from loggerhead.controllers.download_ui import DownloadUI
+from loggerhead.controllers.bundle_ui import BundleUI
+
+
+with_history_lock = util.with_lock('_history_lock', 'History')
+
+
+class BranchView (object):
+    def __init__(self, group_name, name, subfolder, absfolder, config,
+                 project_config, root_config):
+        self._group_name = group_name
+        self._name = name
+        self._folder = subfolder
+        self._absfolder = absfolder
+        self._config = config
+        self._project_config = project_config
+        self._root_config = root_config
+        self.log = logging.getLogger('loggerhead.%s' % (name,))
+
+        # branch history
+        self._history_lock = threading.RLock()
+        self._history = None
+        self._closed = False
+
+        self.changes = ChangeLogUI(self)
+        self.revision = RevisionUI(self)
+        self.files = InventoryUI(self)
+        self.annotate = AnnotateUI(self)
+        self.download = DownloadUI(self)
+        self.atom = AtomUI(self)
+        self.bundle = BundleUI(self)
+
+        # force history object to be loaded:
+        self.get_history()
+
+        turbogears.startup.call_on_shutdown.append(self.close)
+
+    @with_history_lock
+    def close(self):
+        # it's important that we cleanly detach the history, so the cache
+        # files can be closed correctly and hopefully remain uncorrupted.
+        # this should also stop any ongoing indexing.
+        self._history.detach()
+        self._history = None
+        self._closed = True
+
+    config = property(lambda self: self._config)
+
+    name = property(lambda self: self._name)
+
+    group_name = property(lambda self: self._group_name)
+
+    def _get_friendly_name(self):
+        name = self._config.get('branch_name', None)
+        if name is not None:
+            return name
+        # try branch-specific config?
+        name = self.get_history().get_config().get_nickname()
+        if name is not None:
+            return name
+        return self._name
+
+    friendly_name = property(_get_friendly_name)
+
+    def _get_description(self):
+        description = self._config.get('description', None)
+        if description is not None:
+            return description
+        # try branch-specific config?
+        description = self.get_history().get_config().get_user_option('description')
+        return description
+
+    description = property(_get_description)
+
+    def _get_branch_url(self):
+        url = self._config.get('url', None)
+        if url is not None:
+            return url
+        # try to assemble one from the project, if an url_prefix was defined.
+        url = self._project_config.get('url_prefix', None)
+        if url is not None:
+            return posixpath.join(url, self._folder) + '/'
+        # try branch-specific config?
+        url = self.get_history().get_config().get_user_option('public_branch')
+        return url
+
+    branch_url = property(_get_branch_url)
+
+    @turbogears.expose()
+    def index(self):
+        raise HTTPRedirect(self.url('/changes'))
+
+    def get_config_item(self, item, default=None):
+        for conf in self._config, self._project_config, self._root_config:
+            if item in conf:
+                return conf[item]
+        return default
+
+    @with_history_lock
+    def get_history(self):
+        """
+        get an up-to-date History object, safely.  each page-view calls this
+        method, and normally it will get the same History object as on previous
+        calls.  but if the bazaar branch on-disk has been updated since this
+        History was created, a new object will be created and returned.
+        """
+        if self._closed:
+            return None
+        if (self._history is None) or self._history.out_of_date():
+            self.log.debug('Reload branch history...')
+            if self._history is not None:
+                self._history.detach()
+            _history = self._history = History.from_folder(
+                self._absfolder, self._name)
+            cache_path = self._config.get('cachepath', None)
+            if cache_path is None:
+                # try the project config
+                cache_path = self._project_config.get('cachepath', None)
+            if cache_path is not None:
+                _history.use_cache(ChangeCache(_history, cache_path))
+                _history.use_file_cache(FileChangeCache(_history, cache_path))
+                _history.use_search_index(TextIndex(_history, cache_path))
+        return self._history
+
+    def check_rebuild(self):
+        h = self.get_history()
+        if h is not None:
+            h.check_rebuild()
+
+    def url(self, elements, **kw):
+        "build an url relative to this branch"
+        if not isinstance(elements, list):
+            elements = [elements]
+        if elements[0].startswith('/'):
+            elements[0] = elements[0][1:]
+        elements = [urllib.quote(x) for x in elements]
+        return turbogears.url([ '/' + self.group_name, self.name ] + elements, **kw)
+
+    def context_url(self, elements, **kw):
+        "build an url relative to this branch, bringing along browsing context"
+        return self.url(elements, **util.get_context(**kw))
+
+    def last_updated(self):
+        h = self.get_history()
+        change = h.get_changes([ h.last_revid ])[0]
+        return change.date

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2008-06-24 05:23:11 +0000
+++ loggerhead/changecache.py	2008-02-27 03:36:09 +0000
@@ -27,10 +27,12 @@
 
 import cPickle
 import os
+import time
 
 from loggerhead import util
 from loggerhead.lockfile import LockFile
 
+
 with_lock = util.with_lock('_lock', 'ChangeCache')
 
 SQLITE_INTERFACE = os.environ.get('SQLITE_INTERFACE', 'sqlite')
@@ -41,12 +43,15 @@
 elif SQLITE_INTERFACE == 'sqlite':
     import sqlite as dbapi2
     _param_marker = '%s'
-
+else:
+    raise AssertionError("bad sqlite interface %r!?"%SQLITE_INTERFACE)
 
 _select_stmt = ("select data from revisiondata where revid = ?"
                 ).replace('?', _param_marker)
 _insert_stmt = ("insert into revisiondata (revid, data) "
                 "values (?, ?)").replace('?', _param_marker)
+_update_stmt = ("update revisiondata set data = ? where revid = ?"
+                ).replace('?', _param_marker)
 
 
 
@@ -75,11 +80,143 @@
             return None
         else:
             return self._unserialize(filechange[0])
-    def add(self, revid_obj_pairs):
+    def add(self, revid_obj_pairs, commit=True):
         for  (r, d) in revid_obj_pairs:
             self.cursor.execute(_insert_stmt, (r, self._serialize(d)))
-        self.connection.commit()
-
+        if commit:
+            self.connection.commit()
+    def update(self, revid_obj_pairs, commit=True):
+        for  (r, d) in revid_obj_pairs:
+            self.cursor.execute(_update_stmt, (self._serialize(d), r))
+        if commit:
+            self.connection.commit()
+    def count(self):
+        self.cursor.execute(
+            "select count(*) from revisiondata")
+        return self.cursor.fetchone()[0]
+    def close(self, commit=False):
+        if commit:
+            self.connection.commit()
+        self.connection.close()
+
+class ChangeCache (object):
+
+    def __init__(self, history, cache_path):
+        self.history = history
+        self.log = history.log
+
+        if not os.path.exists(cache_path):
+            os.mkdir(cache_path)
+
+        self._changes_filename = os.path.join(cache_path, 'changes.sql')
+
+        # use a lockfile since the cache folder could be shared across different processes.
+        self._lock = LockFile(os.path.join(cache_path, 'lock'))
+        self._closed = False
+
+##         # this is fluff; don't slow down startup time with it.
+##         # but it is racy in tests :(
+##         def log_sizes():
+##             self.log.info('Using change cache %s; %d entries.' % (cache_path, self.size()))
+##         threading.Thread(target=log_sizes).start()
+
+    def _cache(self):
+        return FakeShelf(self._changes_filename)
+
+    @with_lock
+    def close(self):
+        self.log.debug('Closing cache file.')
+        self._closed = True
+
+    @with_lock
+    def closed(self):
+        return self._closed
+
+    @with_lock
+    def flush(self):
+        pass
+
+    @with_lock
+    def get_changes(self, revid_list):
+        """
+        get a list of changes by their revision_ids.  any changes missing
+        from the cache are fetched by calling L{History.get_change_uncached}
+        and inserted into the cache before returning.
+        """
+        out = []
+        missing_revids = []
+        missing_revid_indices = []
+        cache = self._cache()
+        for revid in revid_list:
+            entry = cache.get(revid)
+            if entry is not None:
+                out.append(entry)
+            else:
+                missing_revids.append(revid)
+                missing_revid_indices.append(len(out))
+                out.append(None)
+        if missing_revids:
+            missing_entries = self.history.get_changes_uncached(missing_revids)
+            missing_entry_dict = {}
+            for entry in missing_entries:
+                missing_entry_dict[entry.revid] = entry
+            revid_entry_pairs = []
+            for i, revid in zip(missing_revid_indices, missing_revids):
+                out[i] = entry = missing_entry_dict.get(revid)
+                if entry is not None:
+                    revid_entry_pairs.append((revid, entry))
+            cache.add(revid_entry_pairs)
+        return filter(None, out)
+
+    @with_lock
+    def full(self):
+        cache = self._cache()
+        last_revid = util.to_utf8(self.history.last_revid)
+        revision_history = self.history.get_revision_history()
+        return (cache.count() >= len(revision_history)
+                and cache.get(last_revid) is not None)
+
+    @with_lock
+    def size(self):
+        return self._cache().count()
+
+    def check_rebuild(self, max_time=3600):
+        """
+        check if we need to fill in any missing pieces of the cache.  pull in
+        any missing changes, but don't work any longer than C{max_time}
+        seconds.
+        """
+        if self.closed() or self.full():
+            return
+
+        self.log.info('Building revision cache...')
+        start_time = time.time()
+        last_update = time.time()
+        count = 0
+
+        work = list(self.history.get_revision_history())
+        jump = 100
+        for i in xrange(0, len(work), jump):
+            r = work[i:i + jump]
+            # must call into history so we grab the branch lock (otherwise, lock inversion)
+            self.history.get_changes(r)
+            if self.closed():
+                self.flush()
+                return
+            count += jump
+            now = time.time()
+            if now - start_time > max_time:
+                self.log.info('Cache rebuilding will pause for now.')
+                self.flush()
+                return
+            if now - last_update > 60:
+                self.log.info('Revision cache rebuilding continues: %d/%d' % (min(count, len(work)), len(work)))
+                last_update = time.time()
+                self.flush()
+            # give someone else a chance at the lock
+            time.sleep(1)
+        self.log.info('Revision cache rebuild completed.')
+        self.flush()
 
 class FileChangeCache(object):
     def __init__(self, history, cache_path):

=== added directory 'loggerhead/config'
=== added file 'loggerhead/config/__init__.py'
=== added file 'loggerhead/config/app.cfg'
--- loggerhead/config/app.cfg	1970-01-01 00:00:00 +0000
+++ loggerhead/config/app.cfg	2008-06-10 04:46:49 +0000
@@ -0,0 +1,31 @@
+[global]
+# The settings in this file should not vary depending on the deployment
+# environment. dev.cfg and prod.cfg are the locations for
+# the different deployment settings. Settings in this file will
+# be overridden by settings in those other files.
+
+# The commented out values below are the defaults
+
+# VIEW
+
+# The sitetemplate is used for overall styling of a site that
+# includes multiple TurboGears applications
+# tg.sitetemplate="<packagename.templates.templatename>"
+
+# Allow every exposed function to be called as json,
+# tg.allow_json = False
+
+# List of Widgets to include on every page.
+# for exemple ['turbogears.mochikit']
+# tg.include_widgets = []
+
+# Set to True if the scheduler should be started
+# tg.scheduler = False
+
+[/static]
+static_filter.on = True
+static_filter.dir = "%(top_level_dir)s/static"
+
+[/favicon.ico]
+static_filter.on = True
+static_filter.file = "%(top_level_dir)s/static/images/favicon.ico"

=== added file 'loggerhead/config/log.cfg'
--- loggerhead/config/log.cfg	1970-01-01 00:00:00 +0000
+++ loggerhead/config/log.cfg	2007-01-14 05:40:40 +0000
@@ -0,0 +1,29 @@
+# LOGGING
+# Logging is often deployment specific, but some handlers and
+# formatters can be defined here.
+
+[logging]
+[[formatters]]
+[[[message_only]]]
+format='*(message)s'
+
+[[[full_content]]]
+format='*(asctime)s *(name)s *(levelname)s *(message)s'
+
+[[handlers]]
+#[[[debug_out]]]
+#class='FileHandler'
+#level='DEBUG'
+#args='("/tmp/log.log",)'
+#formatter='full_content'
+
+#[[[access_out]]]
+#class='StreamHandler'
+#level='INFO'
+#args='(sys.stdout,)'
+#formatter='message_only'
+
+#[[[error_out]]]
+#class='StreamHandler'
+#level='ERROR'
+#args='(sys.stdout,)'

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2008-07-01 02:38:56 +0000
+++ loggerhead/controllers/__init__.py	2008-06-15 06:43:31 +0000
@@ -1,99 +1,131 @@
-#
-# Copyright (C) 2006  Robey Pointer <robey@lag.net>
-# Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import re
-import time
-
-from paste.request import path_info_pop, parse_querystring
-
-from loggerhead import util
-from loggerhead.templatefunctions import templatefunctions
-from loggerhead.zptsupport import load_template
-
-class BufferingWriter(object):
-
-    def __init__(self, writefunc, buf_limit):
-        self.bytes = 0
-        self.buf = []
-        self.buflen = 0
-        self.writefunc = writefunc
-        self.bytes_saved = 0
-        self.buf_limit = buf_limit
-
-    def flush(self):
-        chunk = ''.join(self.buf)
-        chunk = re.sub(r'\s*\n\s*', '\n', chunk)
-        chunk = re.sub(r'[ \t]+', ' ', chunk)
-        self.bytes_saved += self.buflen - len(chunk)
-        self.writefunc(chunk)
-        self.buf = []
-        self.buflen = 0
-
-    def write(self, data):
-        self.buf.append(data)
-        self.buflen += len(data)
-        self.bytes += len(data)
-        if self.buflen > self.buf_limit:
-            self.flush()
-
-class TemplatedBranchView(object):
-
-    template_path = None
-
-    def __init__(self, branch, history):
-        self._branch = branch
-        self._history = history
-        self.log = branch.log
-
-    def __call__(self, environ, start_response):
-        z = time.time()
-        h = self._history
-        kw = dict(parse_querystring(environ))
-        util.set_context(kw)
-
-        args = []
-        while 1:
-            arg = path_info_pop(environ)
-            if arg is None:
-                break
-            args.append(arg)
-
-        vals = {
-            'branch': self._branch,
-            'util': util,
-            'history': h,
-            'url': self._branch.context_url,
-        }
-        vals.update(templatefunctions)
-        headers = {}
-        vals.update(self.get_values(h, args, kw, headers))
-
-        self.log.info('Getting information for %s: %r secs' % (
-            self.__class__.__name__, time.time() - z,))
-        if 'Content-Type' not in headers:
-            headers['Content-Type'] = 'text/html'
-        writer = start_response("200 OK", headers.items())
-        template = load_template(self.template_path)
-        z = time.time()
-        w = BufferingWriter(writer, 8192)
-        template.expand_into(w, **vals)
-        w.flush()
-        self.log.info('Rendering %s: %r secs, %s bytes, %s (%2.1f%%) bytes saved' % (
-            self.__class__.__name__, time.time() - z, w.bytes, w.bytes_saved, 100.0*w.bytes_saved/w.bytes))
-        return []
+## #
+## # Copyright (C) 2006  Robey Pointer <robey@lag.net>
+## # Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
+## #
+## # This program is free software; you can redistribute it and/or modify
+## # it under the terms of the GNU General Public License as published by
+## # the Free Software Foundation; either version 2 of the License, or
+## # (at your option) any later version.
+## #
+## # This program is distributed in the hope that it will be useful,
+## # but WITHOUT ANY WARRANTY; without even the implied warranty of
+## # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## # GNU General Public License for more details.
+## #
+## # You should have received a copy of the GNU General Public License
+## # along with this program; if not, write to the Free Software
+## # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+## #
+
+## import logging
+## import os
+## import re
+
+## import turbogears
+## from turbogears import controllers
+## from configobj import ConfigObj
+
+## from loggerhead import util
+## from loggerhead.branchview import BranchView
+## from loggerhead.history import is_branch
+## from loggerhead.templatefunctions import templatefunctions
+
+## log = logging.getLogger("loggerhead.controllers")
+
+
+## def cherrypy_friendly(s):
+##     """
+##     convert a config section name into a name that pleases cherrypy.
+##     """
+##     return re.sub(r'[^\w\d_]', '_', s)
+
+
+## class Project (object):
+##     def __init__(self, name, config, root_config):
+##         self.name = name
+##         self.friendly_name = config.get('name', name)
+##         self.description = config.get('description', '')
+##         self.long_description = config.get('long_description', '')
+##         self._config = config
+##         self._root_config = root_config
+        
+##         self._views = []
+##         for view_name in config.sections:
+##             log.debug('Configuring (project %s) branch %s...', name, view_name)
+##             self._add_view(view_name, config[view_name], config[view_name].get('folder'))
+        
+##         self._auto_folder = config.get('auto_publish_folder', None)
+##         self._auto_list = []
+##         if self._auto_folder is not None:
+##             self._recheck_auto_folders()
+    
+##     def _recheck_auto_folders(self):
+##         if self._auto_folder is None:
+##             return
+##         auto_list = []
+##         # scan a folder for bazaar branches, and add them automatically
+##         for path, folders, filenames in os.walk(self._auto_folder):
+##             for folder in folders:
+##                 folder = os.path.join(path, folder)
+##                 if is_branch(folder):
+##                     auto_list.append(folder)
+##         auto_list.sort()
+##         if auto_list == self._auto_list:
+##             # nothing has changed; do nothing.
+##             return
+
+##         # rebuild views:
+##         log.debug('Rescanning auto-folder for project %s ...', self.name)
+##         self._views = []
+##         for folder in auto_list:
+##             view_name = os.path.basename(folder)
+##             log.debug('Auto-configuring (project %s) branch %s...', self.name, view_name)
+##             self._add_view(view_name, ConfigObj(), folder)
+##         self._auto_list = auto_list
+        
+##     def _add_view(self, view_name, view_config, folder):
+##         c_view_name = cherrypy_friendly(view_name)
+##         view = BranchView(
+##             self.name, c_view_name, view_name, folder, view_config,
+##             self._config, self._root_config)
+##         self._views.append(view)
+##         setattr(self, c_view_name, view)
+        
+##     views = property(lambda self: self._views)
+
+
+## class Root (controllers.RootController):
+##     def __init__(self, config):
+##         self._projects = []
+##         self._config = config
+##         for project_name in self._config.sections:
+##             c_project_name = cherrypy_friendly(project_name)
+##             project = Project(
+##                 c_project_name, self._config[project_name], self._config)
+##             self._projects.append(project)
+##             setattr(self, c_project_name, project)
+        
+##     @turbogears.expose(template='zpt:loggerhead.templates.browse')
+##     def index(self):
+##         for p in self._projects:
+##             p._recheck_auto_folders()
+##         vals = {
+##             'projects': self._projects,
+##             'util': util,
+##             'title': self._config.get('title', None),
+##         }
+##         vals.update(templatefunctions)
+##         return vals
+
+##     def _check_rebuild(self):
+##         for p in self._projects:
+##             for v in p.views:
+##                 v.check_rebuild()
+
+
+
+## # for use in profiling the very-slow get_change() method:
+## #h = Root.bazaar.bzr_dev.get_history()
+## #w = list(h.get_revision_history())
+## #h._get_changes_profiled(w[:100])
 

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2008-06-25 00:00:19 +0000
+++ loggerhead/controllers/annotate_ui.py	2008-06-16 07:27:01 +0000
@@ -17,14 +17,25 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import logging
 import os
 import posixpath
+import time
 
+from paste.request import path_info_pop
 from paste.httpexceptions import HTTPBadRequest
 
-from loggerhead.controllers import TemplatedBranchView
 from loggerhead import util
-
+from loggerhead.templatefunctions import templatefunctions
+
+
+from turbosimpletal import TurboZpt
+
+t = TurboZpt()
+tt = t.load_template('loggerhead.templates.annotate')
+
+
+log = logging.getLogger("loggerhead.controllers")
 
 def dirname(path):
     while path.endswith('/'):
@@ -33,42 +44,70 @@
     return path
 
 
-class AnnotateUI (TemplatedBranchView):
-
-    template_path = 'loggerhead.templates.annotate'
-
-    def get_values(self, h, args, kw, headers):
-        if len(args) > 0:
-            revid = h.fix_revid(args[0])
-        else:
-            revid = h.last_revid
-
-        path = None
-        if len(args) > 1:
-            path = '/'.join(args[1:])
-            if not path.startswith('/'):
-                path = '/' + path
-
-        file_id = kw.get('file_id', None)
-        if (file_id is None) and (path is None):
-            raise HTTPBadRequest('No file_id or filename provided to annotate')
-
-        if file_id is None:
-            file_id = h.get_file_id(revid, path)
-
-        # no navbar for revisions
-        navigation = util.Container()
-
-        if path is None:
-            path = h.get_path(revid, file_id)
-        filename = os.path.basename(path)
-
-        return {
-            'revid': revid,
-            'file_id': file_id,
-            'path': path,
-            'filename': filename,
-            'navigation': navigation,
-            'change': h.get_changes([ revid ])[0],
-            'contents': list(h.annotate_file(file_id, revid)),
-        }
+class AnnotateUI (object):
+
+    def __init__(self, branch):
+        # BranchView object
+        self._branch = branch
+        self.log = branch.log
+
+    def default(self, request, response):
+        z = time.time()
+        h = self._branch.history
+        kw = request.GET
+        util.set_context(kw)
+
+        h._branch.lock_read()
+        try:
+            args = []
+            while 1:
+                arg = path_info_pop(request.environ)
+                if arg is None:
+                    break
+                args.append(arg)
+
+            if len(args) > 0:
+                revid = h.fix_revid(args[0])
+            else:
+                revid = h.last_revid
+
+            path = None
+            if len(args) > 1:
+                path = '/'.join(args[1:])
+                if not path.startswith('/'):
+                    path = '/' + path
+
+            file_id = kw.get('file_id', None)
+            if (file_id is None) and (path is None):
+                raise HTTPBadRequest('No file_id or filename provided to annotate')
+
+            if file_id is None:
+                file_id = h.get_file_id(revid, path)
+
+            # no navbar for revisions
+            navigation = util.Container()
+
+            if path is None:
+                path = h.get_path(revid, file_id)
+            filename = os.path.basename(path)
+
+            vals = {
+                'branch': self._branch,
+                'util': util,
+                'revid': revid,
+                'file_id': file_id,
+                'path': path,
+                'filename': filename,
+                'history': h,
+                'navigation': navigation,
+                'change': h.get_changes([ revid ])[0],
+                'contents': list(h.annotate_file(file_id, revid)),
+                'url': self._branch.context_url,
+            }
+            vals.update(templatefunctions)
+            h.flush_cache()
+            self.log.info('/annotate: %r secs' % (time.time() - z,))
+            response.headers['Content-Type'] = 'text/html'
+            tt.expand_(response, **vals)
+        finally:
+            h._branch.unlock()

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2008-07-01 02:38:56 +0000
+++ loggerhead/controllers/atom_ui.py	2008-06-16 08:08:33 +0000
@@ -17,22 +17,43 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-from loggerhead.controllers import TemplatedBranchView
-
-
-class AtomUI (TemplatedBranchView):
-
-    template_path = 'loggerhead.templates.atom'
-
-    def get_values(self, h, args, kw, headers):
-
-        pagesize = int(20)#self._branch.config.get('pagesize', '20'))
-
-        revid_list = h.get_file_view(h.last_revid, None)
-        entries = list(h.get_changes(list(revid_list)[:pagesize]))
-
-        headers['Content-Type'] = 'application/atom+xml'
-        return {
-            'changes': entries,
-            'updated': entries[0].date.isoformat() + 'Z',
-        }
+
+from loggerhead import util
+from loggerhead.templatefunctions import templatefunctions
+
+from turbosimpletal import TurboZpt
+
+t = TurboZpt()
+tt = t.load_template('loggerhead.templates.atom')
+
+
+class AtomUI (object):
+
+    def __init__(self, branch):
+        # BranchView object
+        self._branch = branch
+        self.log = branch.log
+
+    def default(self, response, request):
+        h = self._branch.history
+
+        h._branch.lock_read()
+        try:
+            pagesize = int(20)#self._branch.config.get('pagesize', '20'))
+
+            revid_list = h.get_file_view(h.last_revid, None)
+            entries = list(h.get_changes(list(revid_list)[:pagesize]))
+
+            vals = {
+                'branch': self._branch,
+                'changes': entries,
+                'util': util,
+                'history': h,
+                'updated': entries[0].date.isoformat() + 'Z',
+            }
+            vals.update(templatefunctions)
+            h.flush_cache()
+            response.headers['Content-Type'] = 'application/atom+xml'
+            tt.expand_(response, **vals)
+        finally:
+            h._branch.unlock()

=== added file 'loggerhead/controllers/bundle_ui.py'
--- loggerhead/controllers/bundle_ui.py	1970-01-01 00:00:00 +0000
+++ loggerhead/controllers/bundle_ui.py	2008-06-16 08:08:33 +0000
@@ -0,0 +1,63 @@
+#
+# Copyright (C) 2006  Robey Pointer <robey@lag.net>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+import time
+
+from paste import httpexceptions
+from paste.request import path_info_pop
+
+class BundleUI (object):
+
+    def __init__(self, branch):
+        # BranchView object
+        self._branch = branch
+        self.log = branch.log
+
+    def default(self, request, response):
+        # /bundle/<rev_id>/[<compare_rev_id>/]filename
+        z = time.time()
+        h = self._branch.history
+
+        h._branch.lock_read()
+        try:
+            args = []
+            while 1:
+                arg = path_info_pop(request.environ)
+                if arg is None:
+                    break
+                args.append(arg)
+            if len(args) < 1:
+                raise httpexceptions.HTTPMovedPermanently('../changes')
+            revid = h.fix_revid(args[0])
+            if len(args) >= 3:
+                compare_revid = h.fix_revid(args[1])
+            else:
+                compare_revid = None
+
+            try:
+                bundle_data = h.get_bundle(revid, compare_revid)
+            except:
+                self.log.exception('Exception fetching bundle')
+                raise httpexceptions.HTTPServerError('Could not fetch bundle')
+
+            response.headers['Content-Type'] = 'application/octet-stream'
+            response.headers['Content-Length'] = len(bundle_data)
+            response.write(bundle_data)
+            self.log.info('/bundle: %r seconds' % (time.time() - z,))
+        finally:
+            h._branch.unlock()

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2008-06-30 08:38:49 +0000
+++ loggerhead/controllers/changelog_ui.py	2008-06-16 07:27:01 +0000
@@ -17,87 +17,117 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import time
+
 from paste.httpexceptions import HTTPServerError
+from paste.request import path_info_pop
 
 from loggerhead import util
-from loggerhead.controllers import TemplatedBranchView
-
-
-class ChangeLogUI(TemplatedBranchView):
-
-    template_path = 'loggerhead.templates.changelog'
-
-    def get_values(self, h, args, kw, headers):
-        if args:
-            revid = h.fix_revid(args[0])
-        else:
-            revid = None
-
-        filter_file_id = kw.get('filter_file_id', None)
-        query = kw.get('q', None)
-        start_revid = h.fix_revid(kw.get('start_revid', None))
-        orig_start_revid = start_revid
-        pagesize = 20#int(config.get('pagesize', '20'))
-        search_failed = False
-
+from loggerhead.templatefunctions import templatefunctions
+
+
+from turbosimpletal import TurboZpt
+
+t = TurboZpt()
+tt = t.load_template('loggerhead.templates.changelog')
+
+class ChangeLogUI (object):
+    
+    def __init__(self, branch):
+        # BranchView object
+        self._branch = branch
+        self.log = branch.log
+        
+    def default(self, request, response):
+        z = time.time()
+        h = self._branch.history
+        #config = self._branch.config
+
+        h._branch.lock_read()
         try:
-            revid, start_revid, revid_list = h.get_view(
-                revid, start_revid, filter_file_id, query)
-            util.set_context(kw)
-
-            if (query is not None) and (len(revid_list) == 0):
-                search_failed = True
-
-            if len(revid_list) == 0:
-                scan_list = revid_list
+            kw = request.GET
+            arg = path_info_pop(request.environ)
+            if arg:
+                revid = h.fix_revid(arg)
             else:
-                if revid in revid_list: # XXX is this always true?
-                    i = revid_list.index(revid)
+                revid = None
+
+            filter_file_id = kw.get('filter_file_id', None)
+            query = kw.get('q', None)
+            start_revid = h.fix_revid(kw.get('start_revid', None))
+            orig_start_revid = start_revid
+            pagesize = 20#int(config.get('pagesize', '20'))
+            search_failed = False
+
+            try:
+                revid, start_revid, revid_list = h.get_view(
+                    revid, start_revid, filter_file_id, query)
+                kw['start_revid'] = start_revid
+                util.set_context(kw)
+
+                if (query is not None) and (len(revid_list) == 0):
+                    search_failed = True
+
+                if len(revid_list) == 0:
+                    scan_list = revid_list
                 else:
-                    i = None
-                scan_list = revid_list[i:]
-            change_list = scan_list[:pagesize]
-            changes = list(h.get_changes(change_list))
-            h.add_changes(changes)
-        except:
-            self.log.exception('Exception fetching changes')
-            raise HTTPServerError('Could not fetch changes')
-
-        navigation = util.Container(
-            pagesize=pagesize, revid=revid, start_revid=start_revid,
-            revid_list=revid_list, filter_file_id=filter_file_id,
-            scan_url='/changes', branch=self._branch, feed=True, history=h)
-        if query is not None:
-            navigation.query = query
-        util.fill_in_navigation(navigation)
-
-        # add parent & merge-point branch-nick info, in case it's useful
-        h.get_branch_nicks(changes)
-
-        # does every change on this page have the same committer?  if so,
-        # tell the template to show committer info in the "details block"
-        # instead of on each line.
-        all_same_author = True
-
-        if changes:
-            author = changes[0].author
-            for e in changes[1:]:
-                if e.author != author:
-                    all_same_author = False
-                    break
-
-        return {
-            'branch': self._branch,
-            'changes': changes,
-            'util': util,
-            'history': h,
-            'revid': revid,
-            'navigation': navigation,
-            'filter_file_id': filter_file_id,
-            'start_revid': start_revid,
-            'viewing_from': (orig_start_revid is not None) and (orig_start_revid != h.last_revid),
-            'query': query,
-            'search_failed': search_failed,
-            'all_same_author': all_same_author,
-            'url': self._branch.context_url,
-        }
+                    if revid in revid_list: # XXX is this always true?
+                        i = revid_list.index(revid)
+                    else:
+                        i = None
+                    scan_list = revid_list[i:]
+                change_list = scan_list[:pagesize]
+                changes = list(h.get_changes(change_list))
+                h.add_changes(changes)
+            except:
+                self.log.exception('Exception fetching changes')
+                raise HTTPServerError('Could not fetch changes')
+
+            navigation = util.Container(
+                pagesize=pagesize, revid=revid, start_revid=start_revid,
+                revid_list=revid_list, filter_file_id=filter_file_id,
+                scan_url='/changes', branch=self._branch, feed=True)
+            if query is not None:
+                navigation.query = query
+            util.fill_in_navigation(navigation)
+
+            # add parent & merge-point branch-nick info, in case it's useful
+            h.get_branch_nicks(changes)
+
+            # does every change on this page have the same committer?  if so,
+            # tell the template to show committer info in the "details block"
+            # instead of on each line.
+            all_same_author = True
+
+            if changes:
+                author = changes[0].author
+                for e in changes[1:]:
+                    if e.author != author:
+                        all_same_author = False
+                        break
+
+            def url(pathargs, **kw):
+                return self._branch.url(pathargs, **util.get_context(**kw))
+
+            vals = {
+                'branch': self._branch,
+                'changes': changes,
+                'util': util,
+                'history': h,
+                'revid': revid,
+                'navigation': navigation,
+                'filter_file_id': filter_file_id,
+                'start_revid': start_revid,
+                'viewing_from': (orig_start_revid is not None) and (orig_start_revid != h.last_revid),
+                'query': query,
+                'search_failed': search_failed,
+                'all_same_author': all_same_author,
+                'url': self._branch.context_url,
+            }
+            vals.update(templatefunctions)
+            h.flush_cache()
+            self.log.info('/changes %r: %r secs' % (revid, time.time() - z))
+            response.headers['Content-Type'] = 'text/html'
+            tt.expand_(response, **vals)
+        finally:
+            h._branch.unlock()

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2008-07-01 02:38:56 +0000
+++ loggerhead/controllers/download_ui.py	2008-06-16 08:08:33 +0000
@@ -29,39 +29,39 @@
 
 class DownloadUI (object):
 
-    def __init__(self, branch, history):
+    def __init__(self, branch):
+        # BranchView object
         self._branch = branch
-        self._history = history
         self.log = branch.log
 
-    def __call__(self, environ, start_response):
+    def default(self, request, response):
         # /download/<rev_id>/<file_id>/[filename]
         z = time.time()
-
-        h = self._history
-
-        args = []
-        while 1:
-            arg = path_info_pop(environ)
-            if arg is None:
-                break
-            args.append(arg)
-
-        if len(args) < 2:
-            raise httpexceptions.HTTPMovedPermanently(self._branch.url('../changes'))
-
-        revid = h.fix_revid(args[0])
-        file_id = args[1]
-        path, filename, content = h.get_file(file_id, revid)
-        mime_type, encoding = mimetypes.guess_type(filename)
-        if mime_type is None:
-            mime_type = 'application/octet-stream'
-
-        self.log.info('/download %s @ %s (%d bytes)', path, h.get_revno(revid), len(content))
-        headers = [
-            ('Content-Type', mime_type),
-            ('Content-Length', len(content)),
-            ('Content-Disposition', 'attachment; filename=%s'%(filename,)),
-            ]
-        start_response('200 OK', headers)
-        return [content]
+        h = self._branch.history
+
+        h._branch.lock_read()
+        try:
+            args = []
+            while 1:
+                arg = path_info_pop(request.environ)
+                if arg is None:
+                    break
+                args.append(arg)
+
+            if len(args) < 2:
+                raise httpexceptions.HTTPMovedPermanently(self._branch.url('../changes'))
+
+            revid = h.fix_revid(args[0])
+            file_id = args[1]
+            path, filename, content = h.get_file(file_id, revid)
+            mime_type, encoding = mimetypes.guess_type(filename)
+            if mime_type is None:
+                mime_type = 'application/octet-stream'
+
+            self.log.info('/download %s @ %s (%d bytes)', path, h.get_revno(revid), len(content))
+            response.headers['Content-Type'] = mime_type
+            response.headers['Content-Length'] = len(content)
+            response.headers['Content-Disposition'] = 'attachment; filename=%s'%(filename,)
+            response.write(content)
+        finally:
+            h._branch.unlock()

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2008-06-25 00:00:19 +0000
+++ loggerhead/controllers/inventory_ui.py	2008-06-16 07:27:01 +0000
@@ -19,11 +19,16 @@
 
 import logging
 import posixpath
+import time
 
+from loggerhead import util
+from loggerhead.templatefunctions import templatefunctions
+from turbosimpletal import TurboZpt
 from paste.httpexceptions import HTTPServerError
+from paste.request import path_info_pop
 
-from loggerhead import util
-from loggerhead.controllers import TemplatedBranchView
+t = TurboZpt()
+tt = t.load_template('loggerhead.templates.inventory')
 
 
 log = logging.getLogger("loggerhead.controllers")
@@ -34,60 +39,84 @@
     path = posixpath.dirname(path)
     return path
 
-
-class InventoryUI(TemplatedBranchView):
-
-    template_path = 'loggerhead.templates.inventory'
-
-    def get_values(self, h, args, kw, headers):
-        if len(args) > 0:
-            revid = h.fix_revid(args[0])
-        else:
-            revid = h.last_revid
-
+        
+class InventoryUI (object):
+
+    def __init__(self, branch):
+        # BranchView object
+        self._branch = branch
+        self.log = branch.log
+
+    def default(self, request, response):
+        z = time.time()
+        h = self._branch.history
+        kw = request.GET
+        util.set_context(kw)
+
+        h._branch.lock_read()
         try:
-            inv = h.get_inventory(revid)
-        except:
-            self.log.exception('Exception fetching changes')
-            raise HTTPServerError('Could not fetch changes')
-
-        file_id = kw.get('file_id', inv.root.file_id)
-        start_revid = kw.get('start_revid', None)
-        sort_type = kw.get('sort', None)
-
-        # no navbar for revisions
-        navigation = util.Container()
-
-        change = h.get_changes([ revid ])[0]
-        # add parent & merge-point branch-nick info, in case it's useful
-        h.get_branch_nicks([ change ])
-
-        path = inv.id2path(file_id)
-        if not path.startswith('/'):
-            path = '/' + path
-        idpath = inv.get_idpath(file_id)
-        if len(idpath) > 1:
-            updir = dirname(path)
-            updir_file_id = idpath[-2]
-        else:
-            updir = None
-            updir_file_id = None
-        if updir == '/':
-            updir_file_id = None
-
-        return {
-            'branch': self._branch,
-            'util': util,
-            'revid': revid,
-            'change': change,
-            'file_id': file_id,
-            'path': path,
-            'updir': updir,
-            'updir_file_id': updir_file_id,
-            'filelist': h.get_filelist(inv, file_id, sort_type),
-            'history': h,
-            'posixpath': posixpath,
-            'navigation': navigation,
-            'url': self._branch.context_url,
-            'start_revid': start_revid,
-        }
+            args = []
+            while 1:
+                arg = path_info_pop(request.environ)
+                if arg is None:
+                    break
+                args.append(arg)
+
+            if len(args) > 0:
+                revid = h.fix_revid(args[0])
+            else:
+                revid = h.last_revid
+
+            try:
+                inv = h.get_inventory(revid)
+            except:
+                self.log.exception('Exception fetching changes')
+                raise HTTPServerError('Could not fetch changes')
+
+            file_id = kw.get('file_id', inv.root.file_id)
+            start_revid = kw.get('start_revid', None)
+            sort_type = kw.get('sort', None)
+
+            # no navbar for revisions
+            navigation = util.Container()
+
+            change = h.get_changes([ revid ])[0]
+            # add parent & merge-point branch-nick info, in case it's useful
+            h.get_branch_nicks([ change ])
+
+            path = inv.id2path(file_id)
+            if not path.startswith('/'):
+                path = '/' + path
+            idpath = inv.get_idpath(file_id)
+            if len(idpath) > 1:
+                updir = dirname(path)
+                updir_file_id = idpath[-2]
+            else:
+                updir = None
+                updir_file_id = None
+            if updir == '/':
+                updir_file_id = None
+
+            vals = {
+                'branch': self._branch,
+                'util': util,
+                'revid': revid,
+                'change': change,
+                'file_id': file_id,
+                'path': path,
+                'updir': updir,
+                'updir_file_id': updir_file_id,
+                'filelist': h.get_filelist(inv, file_id, sort_type),
+                'history': h,
+                'posixpath': posixpath,
+                'navigation': navigation,
+                'url': self._branch.context_url,
+                'start_revid': start_revid,
+            }
+            vals.update(templatefunctions)
+            h.flush_cache()
+            self.log.info('/inventory %r: %r secs' % (revid, time.time() - z))
+            response.headers['Content-Type'] = 'text/html'
+            tt.expand_(response, **vals)
+        finally:
+            h._branch.unlock()

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2008-06-30 08:38:49 +0000
+++ loggerhead/controllers/revision_ui.py	2008-06-16 07:27:01 +0000
@@ -17,76 +17,106 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import time
+
 from paste.httpexceptions import HTTPServerError
+from paste.request import path_info_pop
 
 from loggerhead import util
-from loggerhead.controllers import TemplatedBranchView
+from loggerhead.templatefunctions import templatefunctions
+from turbosimpletal import TurboZpt
+
+t = TurboZpt()
+tt = t.load_template('loggerhead.templates.revision')
 
 
 DEFAULT_LINE_COUNT_LIMIT = 3000
 
 
-class RevisionUI(TemplatedBranchView):
-
-    template_path = 'loggerhead.templates.revision'
-
-    def get_values(self, h, args, kw, headers):
-
-        if len(args) > 0:
-            revid = h.fix_revid(args[0])
-        else:
-            revid = None
-
-        filter_file_id = kw.get('filter_file_id', None)
-        start_revid = h.fix_revid(kw.get('start_revid', None))
-        query = kw.get('q', None)
-        remember = h.fix_revid(kw.get('remember', None))
-        compare_revid = h.fix_revid(kw.get('compare_revid', None))
-
+class RevisionUI (object):
+
+    def __init__(self, branch):
+        # BranchView object
+        self._branch = branch
+        self.log = branch.log
+
+    def default(self, request, response):
+        z = time.time()
+        h = self._branch.history
+        kw = request.GET
+        util.set_context(kw)
+        
+        h._branch.lock_read()
         try:
-            revid, start_revid, revid_list = h.get_view(revid, start_revid, filter_file_id, query)
-        except:
-            self.log.exception('Exception fetching changes')
-            raise HTTPServerError('Could not fetch changes')
-
-        navigation = util.Container(
-            revid_list=revid_list, revid=revid, start_revid=start_revid,
-            filter_file_id=filter_file_id, pagesize=1,
-            scan_url='/revision', branch=self._branch, feed=True, history=h)
-        if query is not None:
-            navigation.query = query
-        util.fill_in_navigation(navigation)
-
-        change = h.get_change_with_diff(revid, compare_revid)
-        # add parent & merge-point branch-nick info, in case it's useful
-        h.get_branch_nicks([ change ])
-
-        line_count_limit = DEFAULT_LINE_COUNT_LIMIT
-        line_count = 0
-        for file in change.changes.modified:
-            for chunk in file.chunks:
-                line_count += len(chunk.diff)
-
-        # let's make side-by-side diff be the default
-        side_by_side = not kw.get('unified', False)
-        if side_by_side:
-            h.add_side_by_side([ change ])
-
-        return {
-            'branch': self._branch,
-            'revid': revid,
-            'change': change,
-            'start_revid': start_revid,
-            'filter_file_id': filter_file_id,
-            'util': util,
-            'history': h,
-            'navigation': navigation,
-            'query': query,
-            'remember': remember,
-            'compare_revid': compare_revid,
-            'side_by_side': side_by_side,
-            'url': self._branch.context_url,
-            'line_count': line_count,
-            'line_count_limit': line_count_limit,
-            'show_plain_diffs': line_count > line_count_limit,
-        }
+            args = []
+            while 1:
+                arg = path_info_pop(request.environ)
+                if arg is None:
+                    break
+                args.append(arg)
+
+            if len(args) > 0:
+                revid = h.fix_revid(args[0])
+            else:
+                revid = None
+
+            filter_file_id = kw.get('filter_file_id', None)
+            start_revid = h.fix_revid(kw.get('start_revid', None))
+            query = kw.get('q', None)
+            remember = kw.get('remember', None)
+            compare_revid = kw.get('compare_revid', None)
+
+            try:
+                revid, start_revid, revid_list = h.get_view(revid, start_revid, filter_file_id, query)
+            except:
+                self.log.exception('Exception fetching changes')
+                raise HTTPServerError('Could not fetch changes')
+
+            navigation = util.Container(
+                revid_list=revid_list, revid=revid, start_revid=start_revid,
+                filter_file_id=filter_file_id, pagesize=1,
+                scan_url='/revision', branch=self._branch, feed=True)
+            if query is not None:
+                navigation.query = query
+            util.fill_in_navigation(navigation)
+
+            change = h.get_change_with_diff(revid, compare_revid)
+            # add parent & merge-point branch-nick info, in case it's useful
+            h.get_branch_nicks([ change ])
+
+            line_count_limit = DEFAULT_LINE_COUNT_LIMIT
+            line_count = 0
+            for file in change.changes.modified:
+                for chunk in file.chunks:
+                    line_count += len(chunk.diff)
+
+            # let's make side-by-side diff be the default
+            side_by_side = not kw.get('unified', False)
+            if side_by_side:
+                h.add_side_by_side([ change ])
+
+            vals = {
+                'branch': self._branch,
+                'revid': revid,
+                'change': change,
+                'start_revid': start_revid,
+                'filter_file_id': filter_file_id,
+                'util': util,
+                'history': h,
+                'navigation': navigation,
+                'query': query,
+                'remember': remember,
+                'compare_revid': compare_revid,
+                'side_by_side': side_by_side,
+                'url': self._branch.context_url,
+                'line_count': line_count,
+                'line_count_limit': line_count_limit,
+                'show_plain_diffs': line_count > line_count_limit,
+            }
+            vals.update(templatefunctions)
+            h.flush_cache()
+            self.log.info('/revision: %r seconds' % (time.time() - z,))
+            response.headers['Content-Type'] = 'text/html'
+            tt.expand_(response, **vals)
+        finally:
+            h._branch.unlock()

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2008-07-01 02:38:56 +0000
+++ loggerhead/history.py	2008-06-11 01:47:08 +0000
@@ -36,10 +36,11 @@
 from StringIO import StringIO
 
 from loggerhead import util
-from loggerhead.wholehistory import compute_whole_history_data
+from loggerhead.util import decorator
 
 import bzrlib
 import bzrlib.branch
+import bzrlib.bundle.serializer
 import bzrlib.diff
 import bzrlib.errors
 import bzrlib.progress
@@ -48,6 +49,22 @@
 import bzrlib.ui
 
 
+with_branch_lock = util.with_lock('_lock', 'branch')
+
+
+@decorator
+def with_bzrlib_read_lock(unbound):
+    def bzrlib_read_locked(self, *args, **kw):
+        #self.log.debug('-> %r bzr lock', id(threading.currentThread()))
+        self._branch.repository.lock_read()
+        try:
+            return unbound(self, *args, **kw)
+        finally:
+            self._branch.repository.unlock()
+            #self.log.debug('<- %r bzr lock', id(threading.currentThread()))
+    return bzrlib_read_locked
+
+
 # bzrlib's UIFactory is not thread-safe
 uihack = threading.local()
 
@@ -172,44 +189,139 @@
 
 
 class History (object):
-    """Decorate a branch to provide information for rendering.
-
-    History objects are expected to be short lived -- when serving a request
-    for a particular branch, open it, read-lock it, wrap a History object
-    around it, serve the request, throw the History object away, unlock the
-    branch and throw it away.
-
-    :ivar _file_change_cache: xx
-    """
-
-    def __init__(self, branch, whole_history_data_cache):
-        assert branch.is_locked(), (
-            "Can only construct a History object with a read-locked branch.")
+
+    def __init__(self):
+        self._change_cache = None
         self._file_change_cache = None
+        self._index = None
+        self._lock = threading.RLock()
+
+    @classmethod
+    def from_branch(cls, branch, name=None):
+        z = time.time()
+        self = cls()
         self._branch = branch
-        self.log = logging.getLogger('loggerhead.%s' % (branch.nick,))
-
-        self.last_revid = branch.last_revision()
-
-        whole_history_data = whole_history_data_cache.get(self.last_revid)
-        if whole_history_data is None:
-            whole_history_data = compute_whole_history_data(branch)
-            whole_history_data_cache[self.last_revid] = whole_history_data
-
-        (self._revision_graph, self._full_history, self._revision_info,
-         self._revno_revid, self._merge_sort, self._where_merged
-         ) = whole_history_data
+        self._last_revid = self._branch.last_revision()
+
+        if name is None:
+            name = self._branch.nick
+        self._name = name
+        self.log = logging.getLogger('loggerhead.%s' % (name,))
+
+        graph = branch.repository.get_graph()
+        parent_map = dict(((key, value) for key, value in
+             graph.iter_ancestry([self._last_revid]) if value is not None))
+
+        self._revision_graph = self._strip_NULL_ghosts(parent_map)
+        self._full_history = []
+        self._revision_info = {}
+        self._revno_revid = {}
+        if bzrlib.revision.is_null(self._last_revid):
+            self._merge_sort = []
+        else:
+            self._merge_sort = bzrlib.tsort.merge_sort(
+                self._revision_graph, self._last_revid, generate_revno=True)
+
+        for (seq, revid, merge_depth, revno, end_of_merge) in self._merge_sort:
+            self._full_history.append(revid)
+            revno_str = '.'.join(str(n) for n in revno)
+            self._revno_revid[revno_str] = revid
+            self._revision_info[revid] = (
+                seq, revid, merge_depth, revno_str, end_of_merge)
+
+        # cache merge info
+        self._where_merged = {}
+
+        for revid in self._revision_graph.keys():
+            if self._revision_info[revid][2] == 0:
+                continue
+            for parent in self._revision_graph[revid]:
+                self._where_merged.setdefault(parent, set()).add(revid)
+
+        self.log.info('built revision graph cache: %r secs' % (time.time() - z,))
+        return self
+
+    @staticmethod
+    def _strip_NULL_ghosts(revision_graph):
+        """
+        Copied over from bzrlib meant as a temporary workaround deprecated 
+        methods.
+        """
+
+        # Filter ghosts, and null:
+        if bzrlib.revision.NULL_REVISION in revision_graph:
+            del revision_graph[bzrlib.revision.NULL_REVISION]
+        for key, parents in revision_graph.items():
+            revision_graph[key] = tuple(parent for parent in parents if parent
+                in revision_graph)
+        return revision_graph
+
+    @classmethod
+    def from_folder(cls, path, name=None):
+        b = bzrlib.branch.Branch.open(path)
+        b.lock_read()
+        try:
+            return cls.from_branch(b, name)
+        finally:
+            b.unlock()
+
+    @with_branch_lock
+    def out_of_date(self):
+        # the branch may have been upgraded on disk, in which case we're stale.
+        newly_opened = bzrlib.branch.Branch.open(self._branch.base)
+        if self._branch.__class__ is not \
+               newly_opened.__class__:
+            return True
+        if self._branch.repository.__class__ is not \
+               newly_opened.repository.__class__:
+            return True
+        return self._branch.last_revision() != self._last_revid
+
+    def use_cache(self, cache):
+        self._change_cache = cache
 
     def use_file_cache(self, cache):
         self._file_change_cache = cache
 
+    def use_search_index(self, index):
+        self._index = index
+
     @property
     def has_revisions(self):
         return not bzrlib.revision.is_null(self.last_revid)
 
+    @with_branch_lock
+    def detach(self):
+        # called when a new history object needs to be created, because the
+        # branch history has changed.  we need to immediately close and stop
+        # using our caches, because a new history object will be created to
+        # replace us, using the same cache files.
+        # (may also be called during server shutdown.)
+        if self._change_cache is not None:
+            self._change_cache.close()
+            self._change_cache = None
+        if self._index is not None:
+            self._index.close()
+            self._index = None
+
+    def flush_cache(self):
+        if self._change_cache is None:
+            return
+        self._change_cache.flush()
+
+    def check_rebuild(self):
+        if self._change_cache is not None:
+            self._change_cache.check_rebuild()
+        #if self._index is not None:
+        #    self._index.check_rebuild()
+
+    last_revid = property(lambda self: self._last_revid, None, None)
+
+    @with_branch_lock
     def get_config(self):
         return self._branch.get_config()
 
+
     def get_revno(self, revid):
         if revid not in self._revision_info:
             # ghost parent?
@@ -217,6 +329,9 @@
         seq, revid, merge_depth, revno_str, end_of_merge = self._revision_info[revid]
         return revno_str
 
+    def get_revision_history(self):
+        return self._full_history
+
     def get_revids_from(self, revid_list, start_revid):
         """
         Yield the mainline (wrt start_revid) revisions that merged each
@@ -244,6 +359,7 @@
                 return
             revid = parents[0]
 
+    @with_branch_lock
     def get_short_revision_history_by_fileid(self, file_id):
         # wow.  is this really the only way we can get this list?  by
         # man-handling the weave store directly? :-0
@@ -254,6 +370,7 @@
         revids = [r for r in self._full_history if r in w_revids]
         return revids
 
+    @with_branch_lock
     def get_revision_history_since(self, revid_list, date):
         # if a user asks for revisions starting at 01-sep, they mean inclusive,
         # so start at midnight on 02-sep.
@@ -267,6 +384,32 @@
         index = -index
         return revid_list[index:]
 
+    @with_branch_lock
+    def get_revision_history_matching(self, revid_list, text):
+        self.log.debug('searching %d revisions for %r', len(revid_list), text)
+        z = time.time()
+        # this is going to be painfully slow. :(
+        out = []
+        text = text.lower()
+        for revid in revid_list:
+            change = self.get_changes([ revid ])[0]
+            if text in change.comment.lower():
+                out.append(revid)
+        self.log.debug('searched %d revisions for %r in %r secs', len(revid_list), text, time.time() - z)
+        return out
+
+    def get_revision_history_matching_indexed(self, revid_list, text):
+        self.log.debug('searching %d revisions for %r', len(revid_list), text)
+        z = time.time()
+        if self._index is None:
+            return self.get_revision_history_matching(revid_list, text)
+        out = self._index.find(text, revid_list)
+        self.log.debug('searched %d revisions for %r in %r secs: %d results', len(revid_list), text, time.time() - z, len(out))
+        # put them in some coherent order :)
+        out = [r for r in self._full_history if r in out]
+        return out
+
+    @with_branch_lock
     def get_search_revid_list(self, query, revid_list):
         """
         given a "quick-search" query, try a few obvious possible meanings:
@@ -305,9 +448,14 @@
         if date is not None:
             if revid_list is None:
                 # if no limit to the query was given, search only the direct-parent path.
-                revid_list = list(self.get_revids_from(None, self.last_revid))
+                revid_list = list(self.get_revids_from(None, self._last_revid))
             return self.get_revision_history_since(revid_list, date)
 
+        # check comment fields.
+        if revid_list is None:
+            revid_list = self._full_history
+        return self.get_revision_history_matching_indexed(revid_list, query)
+
     revno_re = re.compile(r'^[\d\.]+$')
     # the date regex are without a final '$' so that queries like
     # "2006-11-30 12:15" still mostly work.  (i think it's better to give
@@ -321,11 +469,12 @@
         if revid is None:
             return revid
         if revid == 'head:':
-            return self.last_revid
+            return self._last_revid
         if self.revno_re.match(revid):
             revid = self._revno_revid[revid]
         return revid
 
+    @with_branch_lock
     def get_file_view(self, revid, file_id):
         """
         Given a revid and optional path, return a (revlist, revid) for
@@ -335,7 +484,7 @@
         If file_id is None, the entire revision history is the list scope.
         """
         if revid is None:
-            revid = self.last_revid
+            revid = self._last_revid
         if file_id is not None:
             # since revid is 'start_revid', possibly should start the path
             # tracing from revid... FIXME
@@ -345,6 +494,7 @@
             revlist = list(self.get_revids_from(None, revid))
         return revlist
 
+    @with_branch_lock
     def get_view(self, revid, start_revid, file_id, query=None):
         """
         use the URL parameters (revid, start_revid, file_id, and query) to
@@ -370,7 +520,7 @@
         contain vital context for future url navigation.
         """
         if start_revid is None:
-            start_revid = self.last_revid
+            start_revid = self._last_revid
 
         if query is None:
             revid_list = self.get_file_view(start_revid, file_id)
@@ -390,16 +540,19 @@
             revid_list = None
 
         revid_list = self.get_search_revid_list(query, revid_list)
-        if revid_list and len(revid_list) > 0:
+        if len(revid_list) > 0:
             if revid not in revid_list:
                 revid = revid_list[0]
             return revid, start_revid, revid_list
         else:
+            # no results
             return None, None, []
 
+    @with_branch_lock
     def get_inventory(self, revid):
         return self._branch.repository.get_revision_inventory(revid)
 
+    @with_branch_lock
     def get_path(self, revid, file_id):
         if (file_id is None) or (file_id == ''):
             return ''
@@ -408,11 +561,13 @@
             path = '/' + path
         return path
 
+    @with_branch_lock
     def get_file_id(self, revid, path):
         if (len(path) > 0) and not path.startswith('/'):
             path = '/' + path
         return self._branch.repository.get_revision_inventory(revid).path2id(path)
 
+
     def get_merge_point_list(self, revid):
         """
         Return the list of revids that have merged this node.
@@ -486,12 +641,16 @@
                 else:
                     p.branch_nick = '(missing)'
 
+    @with_branch_lock
     def get_changes(self, revid_list):
         """Return a list of changes objects for the given revids.
 
         Revisions not present and NULL_REVISION will be ignored.
         """
-        changes = self.get_changes_uncached(revid_list)
+        if self._change_cache is None:
+            changes = self.get_changes_uncached(revid_list)
+        else:
+            changes = self._change_cache.get_changes(revid_list)
         if len(changes) == 0:
             return changes
 
@@ -501,8 +660,11 @@
             merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(change.revid))
             change.merge_points = [util.Container(revid=r, revno=self.get_revno(r)) for r in merge_revids]
             if len(change.parents) > 0:
-                change.parents = [util.Container(revid=r, 
-                    revno=self.get_revno(r)) for r in change.parents]
+                if isinstance(change.parents[0], util.Container):
+                    # old cache stored a potentially-bogus revno
+                    change.parents = [util.Container(revid=p.revid, revno=self.get_revno(p.revid)) for p in change.parents]
+                else:
+                    change.parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in change.parents]
             change.revno = self.get_revno(change.revid)
 
         parity = 0
@@ -512,16 +674,29 @@
 
         return changes
 
+    # alright, let's profile this sucka. (FIXME remove this eventually...)
+    def _get_changes_profiled(self, revid_list):
+        from loggerhead.lsprof import profile
+        import cPickle
+        ret, stats = profile(self.get_changes_uncached, revid_list)
+        stats.sort()
+        stats.freeze()
+        cPickle.dump(stats, open('lsprof.stats', 'w'), 2)
+        self.log.info('lsprof complete!')
+        return ret
+
+    @with_branch_lock
+    @with_bzrlib_read_lock
     def get_changes_uncached(self, revid_list):
-        # FIXME: deprecated method in getting a null revision
         revid_list = filter(lambda revid: not bzrlib.revision.is_null(revid),
                             revid_list)
-        parent_map = self._branch.repository.get_graph().get_parent_map(revid_list)
+        repo = self._branch.repository
+        parent_map = repo.get_graph().get_parent_map(revid_list)
         # We need to return the answer in the same order as the input,
         # less any ghosts.
         present_revids = [revid for revid in revid_list
                           if revid in parent_map]
-        rev_list = self._branch.repository.get_revisions(present_revids)
+        rev_list = repo.get_revisions(present_revids)
 
         return [self._change_from_revision(rev) for rev in rev_list]
 
@@ -568,7 +743,7 @@
         entry = {
             'revid': revision.revision_id,
             'date': commit_time,
-            'author': revision.get_apparent_author(),
+            'author': revision.committer,
             'branch_nick': revision.properties.get('branch-nick', None),
             'short_comment': short_message,
             'comment': revision.message,
@@ -582,6 +757,7 @@
 
         return [self.parse_delta(delta) for delta in delta_list]
 
+    @with_branch_lock
     def get_file_changes(self, entries):
         if self._file_change_cache is None:
             return self.get_file_changes_uncached(entries)
@@ -594,6 +770,7 @@
         for entry, changes in zip(entries, changes_list):
             entry.changes = changes
 
+    @with_branch_lock
     def get_change_with_diff(self, revid, compare_revid=None):
         change = self.get_changes([revid])[0]
 
@@ -612,6 +789,7 @@
 
         return change
 
+    @with_branch_lock
     def get_file(self, file_id, revid):
         "returns (path, filename, data)"
         inv = self.get_inventory(revid)
@@ -744,6 +922,7 @@
             for m in change.changes.modified:
                 m.sbs_chunks = _make_side_by_side(m.chunks)
 
+    @with_branch_lock
     def get_filelist(self, inv, file_id, sort_type=None):
         """
         return the list of all files (and their attributes) within a given
@@ -777,14 +956,11 @@
             file_list.append(file)
 
         if sort_type == 'filename' or sort_type is None:
-            file_list.sort(key=lambda x: x.filename.lower()) # case-insensitive
+            file_list.sort(key=lambda x: x.filename)
         elif sort_type == 'size':
             file_list.sort(key=lambda x: x.size)
         elif sort_type == 'date':
             file_list.sort(key=lambda x: x.change.date)
-        
-        # Always sort by kind to get directories first
-        file_list.sort(key=lambda x: x.kind != 'directory')
 
         parity = 0
         for file in file_list:
@@ -796,6 +972,7 @@
 
     _BADCHARS_RE = re.compile(ur'[\x00-\x08\x0b\x0e-\x1f]')
 
+    @with_branch_lock
     def annotate_file(self, file_id, revid):
         z = time.time()
         lineno = 1
@@ -836,3 +1013,15 @@
             lineno += 1
 
         self.log.debug('annotate: %r secs' % (time.time() - z,))
+
+    @with_branch_lock
+    def get_bundle(self, revid, compare_revid=None):
+        if compare_revid is None:
+            parents = self._revision_graph[revid]
+            if len(parents) > 0:
+                compare_revid = parents[0]
+            else:
+                compare_revid = None
+        s = StringIO()
+        bzrlib.bundle.serializer.write_bundle(self._branch.repository, revid, compare_revid, s)
+        return s.getvalue()

=== added directory 'loggerhead/sqlobject-history'
=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2008-06-20 02:26:54 +0000
+++ loggerhead/templatefunctions.py	2008-06-15 06:43:31 +0000
@@ -1,5 +1,5 @@
 import os
-from loggerhead.zptsupport import zpt
+from turbosimpletal.zptsupport import zpt
 
 templatefunctions = {}
 def templatefunc(func):
@@ -29,15 +29,15 @@
         **templatefunctions)
 
 @templatefunc
-def collapse_button(group, name, branch, normal='block'):
+def collapse_button(group, name, normal='block'):
     return _pt('collapse-button').expand(
-        group=group, name=name, normal=normal, branch=branch,
+        group=group, name=name, normal=normal,
         **templatefunctions)
 
 @templatefunc
-def collapse_all_button(group, branch, normal='block'):
+def collapse_all_button(group, normal='block'):
     return _pt('collapse-all-button').expand(
-        group=group, normal=normal, branch=branch,
+        group=group, normal=normal,
         **templatefunctions)
 
 @templatefunc
@@ -59,3 +59,10 @@
     return _pt('modified-file-link-log').expand(
         url=url, entry=entry, item=item,
         **templatefunctions)
+
+class tg:
+    @staticmethod
+    def url(what):
+        return what
+
+templatefunctions['tg'] =  tg

=== modified file 'loggerhead/templates/annotate.pt'
--- loggerhead/templates/annotate.pt	2008-06-18 08:42:36 +0000
+++ loggerhead/templates/annotate.pt	2008-05-29 04:43:39 +0000
@@ -5,35 +5,48 @@
     <title metal:fill-slot="title"
            tal:content="string:${branch/friendly_name} : contents of ${path}
                         at revision ${change/revno}">
+      ${branch.friendly_name} : contents of ${path} at revision ${change.revno}
     </title>
   </head>
 
   <body>
 
     <h1 metal:fill-slot="heading">
-      <span class="branch-name" tal:content="branch/friendly_name"></span>
+      <span class="branch-name" tal:content="branch/friendly_name">
+        ${branch.friendly_name}
+      </span>
       :
-      <span class="annotate-path" tal:content="path"></span>
-      (revision <tal:revno content="change/revno"></tal:revno>)
+      <span class="annotate-path" tal:content="path">
+        ${path}
+      </span>
+      (revision <tal:revno content="change/revno">${change.revno}</tal:revno>)
     </h1>
 
     <div metal:fill-slot="content">
       <div class="links">
         <div>
           <b>&#8594;</b>
-          <a tal:attributes="href python:url(['/files', change.revno], clear=1)">browse files</a>
-        </div>
-        <div>
-          <b>&#8594;</b>
-          <a tal:attributes="href python:url(['/revision'], clear=1, start_revid=change.revno)">view revision</a>
-        </div>
-        <div>
-          <b>&#8594;</b>
-          <a tal:attributes="href python:url(['/changes'], clear=1, start_revid=change.revno, filter_file_id=file_id)">view changes to this file</a>
-        </div>
-        <div>
-          <b>&#8594;</b>
-          <a tal:attributes="href python:url(['/download', change.revno, file_id, filename])">download file</a>
+          <a tal:attributes="href python:url(['/files', revid], clear=1)">
+            browse files
+          </a>
+        </div>
+        <div>
+          <b>&#8594;</b>
+          <a tal:attributes="href python:url(['/revision'], clear=1, start_revid=revid)">
+            view revision
+          </a>
+        </div>
+        <div>
+          <b>&#8594;</b>
+          <a tal:attributes="href python:url(['/changes'], clear=1, start_revid=revid, filter_file_id=file_id)">
+            view changes to this file
+          </a>
+        </div>
+        <div>
+          <b>&#8594;</b>
+          <a tal:attributes="href python:url(['/download', revid, file_id, filename])">
+            download file
+          </a>
         </div>
       </div>
 
@@ -49,16 +62,22 @@
               tal:attributes="class string:parity${line/parity}">
             <td tal:attributes="class string:lineno ${line/status}">
               <a tal:attributes="name string:L${line/lineno}"
-                 tal:content="line/lineno"></a>
+                 tal:content="line/lineno">
+                ${line.lineno}
+              </a>
             </td>
             <td tal:attributes="class string:revno ${line/status}">
               <a tal:condition="python:line.status=='changed'"
                  tal:content="python:util.trunc(line.change.revno)"
-                 tal:attributes="href python:url(['/revision'], clear=1, start_revid=line.change.revno, filter_file_id=file_id);
-                                 title python:'%s by %s, on %s (%s)'%(line.change.revno, util.hide_email(line.change.author), line.change.date.strftime('%d %b %Y %H:%M'), util.date_time(line.change.date))"></a>
+                 tal:attributes="href python:url(['/revision'], clear=1, start_revid=line.change.revid, filter_file_id=file_id);
+                                 title python:'%s by %s, on %s (%s)'%(line.change.revno, util.hide_email(line.change.author), line.change.date.strftime('%d %b %Y %H:%M'), util.date_time(line.change.date))">
+
+                ${util.trunc(line.change.revno)}
+              </a>
             </td>
             <td tal:attributes="class string:text ${line/status}"
                 tal:content="line/text">
+              ${line.text}
             </td>
           </tr>
         </table>

=== modified file 'loggerhead/templates/atom.pt'
--- loggerhead/templates/atom.pt	2008-06-26 20:42:15 +0000
+++ loggerhead/templates/atom.pt	2008-06-10 04:48:26 +0000
@@ -4,7 +4,7 @@
     bazaar changes for <tal:branch-name content="branch/friendly_name">branch name</tal:branch-name>
   </title>
   <updated tal:content="updated">${updated}</updated>
-  <id tal:content="python:branch.url(['/atom'])">url</id>
+  <id tal:content="python:branch.url(['atom'])">url</id>
   <link rel="self" tal:attributes="href python:branch.url([''])" />
 
   <entry tal:repeat="entry changes">
@@ -14,7 +14,7 @@
     <updated tal:content="entry/date/isoformat">
     Z
     </updated>
-    <id tal:content="python:branch.url(['/revision', entry.revno])">
+    <id tal:content="python:branch.url(['revision', entry.revid])">
       ID
     </id>
     <author>
@@ -26,6 +26,6 @@
       comment
     </content>
     <link rel="alternate"
-          tal:attributes="href python:branch.url(['/revision', entry.revno])" />
+          tal:attributes="href python:branch.url(['revision', entry.revid])" />
   </entry>
 </feed>

=== modified file 'loggerhead/templates/browse.pt'
--- loggerhead/templates/browse.pt	2008-07-01 03:28:31 +0000
+++ loggerhead/templates/browse.pt	2008-06-10 04:49:54 +0000
@@ -45,10 +45,10 @@
               </th>
               <th />
             </tr>
-            <tal:block repeat="view python:views_by_project[project]">
+            <tal:block repeat="view project/views">
               <tr>
                 <td class="name">
-                  <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)"
+                  <a tal:attributes="href python:tg.url(['/' + project.name, view.name])"
                      tal:content="view/friendly_name">
                     ${view.friendly_name}
                   </a>
@@ -60,14 +60,14 @@
                 <td class="last-update"
                     tal:content="python:view.get_history().has_revisions and util._approximatedate(view.last_updated()) or '(no revisions)'"></td>
                 <td class="feed">
-                  <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name + '/atom')"
+                  <a tal:attributes="href python:tg.url(['/' + project.name, view.name, 'atom'])"
                      title="atom feed">
-                    <img tal:attributes="src python:branch.static_url('/static/images/feed-icon-16x16.gif')"
+                    <img tal:attributes="src python:tg.url('/static/images/feed-icon-16x16.gif')"
                          alt="atom feed" />
                   </a>
                 </td>
               </tr>
-              <tr tal:condition="view/branch_url">
+              <tr tal:condition="python:view.branch_url is not None">
                 <td class="name">
                 </td>
                 <td class="description url" colspan="2">

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2008-06-20 02:20:05 +0000
+++ loggerhead/templates/changelog.pt	2008-06-11 04:51:53 +0000
@@ -13,7 +13,7 @@
               />
 
         <script type="text/javascript"
-                tal:attributes="src python:branch.static_url('/static/javascript/collapse.js')">
+                tal:attributes="src python:tg.url('/static/javascript/collapse.js')">
         </script>
       </metal:block>
     </head>
@@ -51,7 +51,7 @@
 
         <p tal:condition="changes"
            class="changelog">
-          <tal:b content="structure python:collapse_all_button('cl', branch)" />
+          <tal:b content="structure python:collapse_all_button('cl')" />
         </p>
 
         <table class="log-entries"
@@ -77,18 +77,18 @@
             <a tal:attributes="name string:entry-${entry/revno}" />
             <tr tal:attributes="class string:revision-header parity${entry/parity}">
               <td class="revision-number">
-                <a tal:attributes="title python:'Show revision '+entry.revno;
-                                   href  python:url(['/revision', entry.revno])"
+                <a tal:attributes="title python:'Show revision '+history.get_revno(entry.revid);
+                                   href  python:url(['/revision', entry.revid])"
                    tal:content="python:util.trunc(entry.revno)">
                   text
                 </a>
               </td>
               <td class="expand-button" tal:define="name entry/revno"
-                  tal:content="structure python:collapse_button('cl', entry.revno, branch)">
+                  tal:content="structure python:collapse_button('cl', entry.revno)">
               </td>
               <td class="summary">
-                <a tal:attributes="title python:'Show revision '+entry.revno;
-                                   href  python:url(['/revision', entry.revno])"
+                <a tal:attributes="title python:'Show revision '+history.get_revno(entry.revid);
+                                   href  python:url(['/revision', entry.revid])"
                    tal:content="entry/short_comment">
                   text
                 </a>
@@ -101,7 +101,7 @@
                         tal:content="python:util._approximatedate(entry.date)"></span>
               </td>
               <td class="inventory-link">
-                <a tal:attributes="href python:branch.url(['/files', entry.revno]);
+                <a tal:attributes="href python:branch.url(['/files', entry.revid]);
                                    title string:Files at revision ${entry/revno}">
                   files
                 </a>
@@ -121,7 +121,7 @@
                     </th>
                     <td class="children">
                       <a title="Show history"
-                         tal:attributes="href python:url(['/changes'], start_revid=merge_point.revno)"
+                         tal:attributes="href python:url(['/changes'], start_revid=merge_point.revid)"
                          tal:content="python:revno_with_nick(merge_point)">
                         class="revlink">
                         ${text}
@@ -136,7 +136,7 @@
                     </th>
                     <td class="parents">
                       <a title="Show history"
-                         tal:attributes="href python:url(['/changes'], start_revid=parent.revno)"
+                         tal:attributes="href python:url(['/changes'], start_revid=parent.revid)"
                          tal:content="python:revno_with_nick(parent)">
                         class="revlink">
                         ${text}

=== modified file 'loggerhead/templates/collapse-all-button.pt'
--- loggerhead/templates/collapse-all-button.pt	2008-06-16 10:13:40 +0000
+++ loggerhead/templates/collapse-all-button.pt	2007-08-30 13:41:20 +0000
@@ -1,14 +1,14 @@
 <tal:block>
   <a tal:attributes="class string:hide-all collapse-${group}-hideall;
                      href string:javascript:collapseAllDisplay('${group}','none')">
-    <img tal:attributes="src python:branch.static_url('/static/images/nav-small-down.gif')"
+    <img tal:attributes="src python:tg.url('/static/images/nav-small-down.gif')"
          width="10" height="10" alt="collapse"
          class="collapse-triangle" />
     collapse all
   </a>
   <a tal:attributes="class string:hide-all collapse-${group}-showall;
                      href string:javascript:collapseAllDisplay('${group}','${normal}')">
-    <img tal:attributes="src python:branch.static_url('/static/images/nav-small-right.gif')"
+    <img tal:attributes="src python:tg.url('/static/images/nav-small-right.gif')"
          width="10" height="10" alt="expand"
          class="collapse-triangle" />
     expand all

=== modified file 'loggerhead/templates/collapse-button.pt'
--- loggerhead/templates/collapse-button.pt	2008-06-16 10:13:40 +0000
+++ loggerhead/templates/collapse-button.pt	2007-08-29 13:31:58 +0000
@@ -2,14 +2,14 @@
   <a tal:attributes="href string:javascript:collapseDisplay('${group}','${name}','none');
                      class string:hide-button collapse-${group}-${name}-hide"
      title="collapse">
-    <img tal:attributes="src python:branch.static_url('/static/images/nav-small-down.gif')"
+    <img tal:attributes="src python:tg.url('/static/images/nav-small-down.gif')"
          width="10" height="10" alt="collapse"
          class="collapse-triangle" />
   </a>
   <a tal:attributes="href string:javascript:collapseDisplay('${group}','${name}','${normal}');
                      class string:show-button collapse-${group}-${name}-show"
      title="expand">
-    <img tal:attributes="src python:branch.static_url('/static/images/nav-small-right.gif')"
+    <img tal:attributes="src python:tg.url('/static/images/nav-small-right.gif')"
          witdh="10" height="10" alt="expand"
          class="collapse-triangle" />
   </a>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2008-06-20 02:13:34 +0000
+++ loggerhead/templates/inventory.pt	2008-06-11 04:53:47 +0000
@@ -20,10 +20,10 @@
 
     <div metal:fill-slot="content">
       <div class="links">
-        <div> <b>&#8594;</b> <a tal:attributes="href python:url(['/revision', change.revno], clear=1, start_revid=change.revno)">
+        <div> <b>&#8594;</b> <a tal:attributes="href python:url(['/revision'], clear=1, start_revid=revid)">
 	    view revision </a>
         </div>
-        <div> <b>&#8594;</b> <a tal:attributes="href python:url(['/changes', change.revno], clear=1, start_revid=change.revno)">
+        <div> <b>&#8594;</b> <a tal:attributes="href python:url(['/changes'], clear=1, start_revid=revid)">
 	    view branch changes </a>
         </div>
       </div>
@@ -81,7 +81,7 @@
           </td>
           <td tal:attributes="class string:filename ${file/kind}">
             <a tal:condition="python:file.kind=='directory'"
-               tal:attributes="href python:url(['/files', change.revno], file_id=file.file_id)"
+               tal:attributes="href python:url(['/files', revid], file_id=file.file_id)"
                tal:content="string:${file/filename}/">
               ${file.filename}/
             </a>
@@ -90,14 +90,14 @@
               ${file.filename}@
             </span>
             <a tal:condition="python:file.kind=='file'"
-               tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id);
+               tal:attributes="href python:url(['/annotate', revid], file_id=file.file_id);
                                title string:Annotate ${file/filename}"
                tal:content="string:${file/filename}">
               ${file.filename}
             </a>
           </td>
           <td class="revision">
-            <a tal:attributes="href python:url(['/revision', file.change.revno], filter_file_id=file.file_id);
+            <a tal:attributes="href python:url(['/revision', file.revid], start_revid=file.revid, file_id=file.file_id);
                                title string:Show revision ${file/change/revno}"
                tal:content="python:util.trunc(file.change.revno, 15)">
               ${text}

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2008-06-16 11:38:05 +0000
+++ loggerhead/templates/macros.pt	2008-06-10 23:21:43 +0000
@@ -9,7 +9,7 @@
     </title>
 
     <link rel="stylesheet"
-          tal:attributes="href python:branch.static_url('/static/css/zptstyle.css')" />
+          tal:attributes="href python:tg.url('/static/css/zptstyle.css')" />
 
     <metal:block metal:define-slot="header_extras" />
   </head>
@@ -32,7 +32,7 @@
             <td align="right" tal:condition="navigation/revid_list|nothing">
               <span tal:condition="navigation/feed" class="rbuttons feed">
                 <a tal:attributes="href python:url(['/atom'])">
-                  <img tal:attributes="src python:branch.static_url('/static/images/feed-icon-16x16.gif')" />
+                  <img tal:attributes="src python:tg.url('/static/images/feed-icon-16x16.gif')" />
                 </a>
               </span>
               <span class="navbuttons">
@@ -73,12 +73,12 @@
     <div class="footer">
       <span class="banner">
         <a href="http://www.bazaar-vcs.org/">
-          <img tal:attributes="src python:branch.static_url('/static/images/bazaar-banner.png')" />
+          <img tal:attributes="src python:tg.url('/static/images/bazaar-banner.png')" />
         </a>
       </span>
       <span class="banner">
         <a href="http://www.lag.net/loggerhead/">
-          <img tal:attributes="src python:branch.static_url('/static/images/loggerhead-banner.png')" />
+          <img tal:attributes="src python:tg.url('/static/images/loggerhead-banner.png')" />
         </a>
       </span>
     </div>

=== modified file 'loggerhead/templates/modified-file-link-log.pt'
--- loggerhead/templates/modified-file-link-log.pt	2008-06-19 23:02:48 +0000
+++ loggerhead/templates/modified-file-link-log.pt	2008-06-11 02:19:53 +0000
@@ -1,5 +1,5 @@
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<a tal:attributes="href python:'javascript:diff_url(\'' + url(['/revision', entry.revno]) + '#' + item.filename + '\')';
+<a tal:attributes="href python:'javascript:diff_url(\'' + url(['/revision', entry.revid]) + '#' + item.filename + '\')';
                    title string:Annotate ${item/filename}"
    tal:content="item/filename" class="filename">
   item/filename

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2008-06-23 22:22:01 +0000
+++ loggerhead/templates/revision.pt	2008-06-11 03:17:41 +0000
@@ -9,7 +9,7 @@
 
       <metal:block fill-slot="header_extras">
         <script type="text/javascript"
-                tal:attributes="src python:branch.static_url('/static/javascript/collapse.js')">
+                tal:attributes="src python:tg.url('/static/javascript/collapse.js')">
         </script>
       </metal:block>
     </head>
@@ -33,38 +33,44 @@
         <div class="links">
           <div>
             <b>&#8594;</b>
-            <a tal:attributes="href python:url(['/files', change.revno])">
+            <a tal:attributes="href python:url(['/files', revid])">
               browse files at revision <tal:b content="change/revno" />
             </a>
           </div>
           <div>
             <b>&#8594;</b>
-            <a tal:attributes="href python:url(['/changes'], start_revid=change.revno)">
+            <a tal:attributes="href python:url(['/changes'], start_revid=revid)">
               view history from revision <tal:b content="change/revno" />
             </a>
           </div>
-          <div tal:condition="python:(remember is not None) and (compare_revid is None) and remember != revid" >
-            <b>&#8594;</b>
-            <a tal:attributes="href python:url(['/revision', change.revno], compare_revid=history.get_revno(remember))">
+          <div tal:condition="python:compare_revid is not None" >
+            <b>&#8594;</b>
+            <a tal:attributes="href python:branch.url(['/bundle', revid, compare_revid, 'bundle.txt'])">
+                download bundle from <tal:b content="python:history.get_revno(compare_revid)" /> to <tal:b content="change/revno" />
+            </a>
+          </div>
+          <div tal:condition="python:(remember is not None) and (compare_revid is None) and (revid != remember)" >
+            <b>&#8594;</b>
+            <a tal:attributes="href python:url(['/revision', revid], compare_revid=remember)">
               compare with revision <tal:b content="python:history.get_revno(remember)" />
             </a>
           </div>
           <div  tal:condition="python:remember != revid">
             <b>&#8594;</b>
-            <a tal:attributes="href python:url(['/revision', change.revno], remember=change.revno, compare_revid=None)">
+            <a tal:attributes="href python:url(['/revision', revid], remember=revid, compare_revid=None)">
               compare with another revision
             </a>
           </div>
           <tal:we-are-comparing condition="python:compare_revid is not None">
             <div>
               <b>&#8594;</b>
-              <a tal:attributes="href python:url([ '/revision', history.get_revno(compare_revid) ], remember=change.revno, compare_revid=change.revno)">
+              <a tal:attributes="href python:url([ '/revision', compare_revid ], remember=revid, compare_revid=revid)">
                 reverse the comparison (<tal:b content="change/revno" /> to <tal:b content="python:history.get_revno(compare_revid)" />)
               </a>
             </div>
             <div>
               <b>&#8594;</b>
-              <a tal:attributes="href python:url(['/revision', change.revno], remember=None, compare_revid=None)">
+              <a tal:attributes="href python:url(['/revision', revid], remember=None, compare_revid=None)">
                 stop comparing with revision <tal:b content="python:history.get_revno(compare_revid)" />
               </a>
             </div>
@@ -76,21 +82,21 @@
         <table class="diff-option-buttons">
           <tr>
             <td>
-              <tal:b content="structure python:collapse_all_button('file', branch, normal='table-row')" />
+              <tal:b content="structure python:collapse_all_button('file', 'table-row')" />
             </td>
 
             <td class="spacey">
               <a href="javascript:show_sbs()"
                  class="hide-all collapse-style-sbs-show"
                  title="collapse">
-                <img tal:attributes="src python:branch.static_url('/static/images/nav-small-out.gif')"
+                <img tal:attributes="src python:tg.url('/static/images/nav-small-out.gif')"
                      width="22" height="10" class="collapse-triangle" />
                 show side by side
               </a>
               <a href="javascript:show_unified()"
                  class="hide-all collapse-style-unified-show"
                  title="expand">
-                <img tal:attributes="src python:branch.static_url('/static/images/nav-small-in.gif')"
+                <img tal:attributes="src python:tg.url('/static/images/nav-small-in.gif')"
                      width="22" height="10" class="collapse-triangle" />
                 show unified diff
               </a>
@@ -118,8 +124,8 @@
               <tal:u define="u python:util.uniq(uniqs, item.file_id)">
                 <tr>
                   <th class="filename" colspan="4">
-                    <tal:b content="structure python:collapse_button('file', u, branch, normal='table-row')" />
-                    <a tal:attributes="href  python:url(['/annotate', change.revno], file_id=item.file_id);
+                    <tal:b content="structure python:collapse_button('file', u, 'table-row')" />
+                    <a tal:attributes="href  python:url(['/annotate', change.revid], file_id=item.file_id);
                                        name  string:${item/filename}-s;
                                        title string:Annotate ${item/filename}"
                        tal:content="item/filename">
@@ -205,8 +211,8 @@
               <tal:u define="u python:util.uniq(uniqs, item.file_id)">
                 <tr>
                   <th class="filename" colspan="4">
-                    <tal:b content="structure python:collapse_button('file', u, branch, normal='table-row')" />
-                    <a tal:attributes="href  python:url(['/annotate', change.revno], file_id=item.file_id);
+                    <tal:b content="structure python:collapse_button('file', u, 'table-row')" />
+                    <a tal:attributes="href  python:url(['/annotate', change.revid], file_id=item.file_id);
                                        name  string:${item/filename}-u;
                                        title string:Annotate ${item/filename}"
                        tal:content="item/filename">

=== modified file 'loggerhead/templates/revisionfilechanges.pt'
--- loggerhead/templates/revisionfilechanges.pt	2008-06-27 04:32:15 +0000
+++ loggerhead/templates/revisionfilechanges.pt	2007-09-05 18:40:01 +0000
@@ -24,7 +24,11 @@
     <td class="files"
         tal:define="filename python:removed[0];
                     file_id  python:removed[1]">
-      <tal:block content="filename" />
+      <a tal:attributes="href  python:url(['/annotate', entry.revid], file_id=file_id);
+                         title string:Annotate ${filename}"
+         tal:content="filename" class="filename">
+        filename
+      </a>
     </td>
   </tr>
   <tr tal:repeat="renamed entry/changes/renamed">

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2008-06-20 02:13:34 +0000
+++ loggerhead/templates/revisioninfo.pt	2008-05-29 05:58:01 +0000
@@ -28,8 +28,8 @@
       <td class="children">
         <a title="Show history"
            tal:attributes="title string:Show revision ${merge_point/revno};
-                                        href python:url(['/revision', merge_point.revno], clear=1,
-                                                        start_revid=merge_point.revid)"
+                           href python:url(['/revision', merge_point.revid],
+                                           clear=1, start_revid=merge_point.revid)"
            tal:content="python:revno_with_nick(merge_point)">
           ${text}
         </a>
@@ -45,7 +45,7 @@
       <td class="parents">
         <a title="Show history"
            tal:attributes="title string:Show revision ${parent/revno};
-                           href python:url(['/revision', parent.revno], clear=1, start_revid=parent.revno)"
+                             href python:url(['/revision', parent.revid], clear=1, start_revid=parent.revid)"
            tal:content="python:revno_with_nick(parent)">
           class="revlink">
           ${text}
@@ -65,17 +65,6 @@
       </td>
     </tr>
 
-    <tr>
-      <th class="revid">
-        revision id:
-      </th>
-      <td class="revid">
-          <span tal:content="python:change.revid">
-              revid
-        </span>
-      </td>
-    </tr>
-
     <tal:block condition="nocall:modified_file_link">
       <tr class="divider">
         <th>

=== modified file 'loggerhead/tests/test_corners.py'
--- loggerhead/tests/test_corners.py	2008-06-20 02:20:05 +0000
+++ loggerhead/tests/test_corners.py	2008-04-18 03:22:47 +0000
@@ -1,8 +1,11 @@
+import re
 import os
 
+import cherrypy
+from turbogears import testutil
+
 from loggerhead.tests.test_simple import BasicTests
 
-
 class TestCornerCases(BasicTests):
     """Tests that excercise various corner cases."""
 
@@ -20,6 +23,29 @@
         self.tree.add(filename)
         self.tree.commit(message=commit_msg)
 
+
+    def test_survive_over_upgrade(self):
+        """Check that running 'bzr upgrade' on a branch does not break an
+        instance of loggerhead that's already looked at it.
+        """
+        self.createBranch()
+
+        msg = 'a very exciting commit message'
+        self.addFileAndCommit('myfilename', msg)
+
+        self.setUpLoggerhead()
+
+        testutil.create_request('/project/branch/changes')
+        assert msg in cherrypy.response.body[0]
+
+        from bzrlib.upgrade import upgrade
+        from bzrlib.bzrdir import format_registry
+        upgrade(self.bzrbranch, format_registry.make_bzrdir('dirstate-tags'))
+
+        testutil.create_request('/project/branch/changes')
+        assert msg in cherrypy.response.body[0]
+
+
     def test_revision_only_changing_execute_bit(self):
         """Check that a commit that only changes the execute bit of a file
         does not break the rendering."""
@@ -34,9 +60,10 @@
         newrevid = self.tree.commit(message='make something executable')
 
         # Check that it didn't break things.
-        app = self.setUpLoggerhead()
-        res = app.get('/revision/'+newrevid)
-        res.mustcontain('executable')
+        self.setUpLoggerhead()
+        testutil.create_request('/project/branch/revision/'+newrevid)
+        assert 'executable' in cherrypy.response.body[0]
+
 
     def test_empty_commit_message(self):
         """Check that an empty commit message does not break the rendering."""
@@ -46,11 +73,12 @@
         self.addFileAndCommit('myfilename', '')
 
         # Check that it didn't break things.
-        app = self.setUpLoggerhead()
-        res = app.get('/changes')
+        self.setUpLoggerhead()
+        testutil.create_request('/project/branch/changes')
         # It's not much of an assertion, but we only really care about
         # "assert not crashed".
-        res.mustcontain('myfilename')
+        assert 'myfilename' in cherrypy.response.body[0]
+
 
     def test_whitespace_only_commit_message(self):
         """Check that a whitespace-only commit message does not break the
@@ -61,8 +89,30 @@
         self.addFileAndCommit('myfilename', '   ')
 
         # Check that it didn't break things.
-        app = self.setUpLoggerhead()
-        res = app.get('/changes')
+        self.setUpLoggerhead()
+        testutil.create_request('/project/branch/changes')
         # It's not much of an assertion, but we only really care about
         # "assert not crashed".
-        res.mustcontain('myfilename')
+        assert 'myfilename' in cherrypy.response.body[0]
+
+    def test_revision_size_limit(self):
+        self.createBranch()
+        msg = 'a very exciting commit message'
+        self.addFileAndCommit('myfilename', msg)
+
+        file_in_branch = open(os.path.join(self.bzrbranch, 'myfilename'), 'w')
+        file_in_branch.write('\n'.join(['line']*100))
+        file_in_branch.close()
+        newrevid = self.tree.commit(message='touch 100 lines')
+
+        self.setUpLoggerhead()
+        cherrypy.root._config['line_count_limit'] = 50
+        testutil.create_request('/project/branch/revision/'+newrevid)
+
+        match = re.search(
+            'Diff of [0-9]+ lines is too long to display richly -- limit '
+            'is 50 lines\\.',
+            cherrypy.response.body[0]
+            )
+
+        assert match is not None

=== modified file 'loggerhead/tests/test_filechangecache.py'
--- loggerhead/tests/test_filechangecache.py	2008-06-25 07:03:06 +0000
+++ loggerhead/tests/test_filechangecache.py	2007-09-10 12:51:42 +0000
@@ -5,12 +5,12 @@
 
 from loggerhead.changecache import FileChangeCache
 
-class MockEntry(object):
+class MockEntry:
     def __init__(self, revid):
         self.revid = revid
 
 
-class MockHistory(object):
+class MockHistory:
     def __init__(self):
         self.fetched_revids = set()
     def get_file_changes_uncached(self, entries):

=== modified file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2008-07-01 04:01:31 +0000
+++ loggerhead/tests/test_simple.py	2008-05-28 22:47:44 +0000
@@ -1,3 +1,4 @@
+from configobj import ConfigObj
 import cgi
 import unittest
 import os
@@ -5,21 +6,19 @@
 import shutil
 import logging
 
-import bzrlib.bzrdir
-import bzrlib.osutils
-from configobj import ConfigObj
-
-from loggerhead.history import History
-from loggerhead.apps.branch import BranchWSGIApp
-from paste.fixture import TestApp
-
-
-def test_config_root():
-    from loggerhead.apps.config import Root
+import cherrypy
+from turbogears import testutil
+
+import bzrlib
+
+from loggerhead.controllers import Root
+
+def test_simple():
     config = ConfigObj()
-    app = TestApp(Root(config))
-    res = app.get('/')
-    res.mustcontain('loggerhead branches')
+    r = Root(config)
+    cherrypy.root = r
+    testutil.create_request('/')
+    assert 'loggerhead branches' in cherrypy.response.body[0]
 
 
 class BasicTests(object):
@@ -52,15 +51,16 @@
     """
 
     def setUpLoggerhead(self):
-        app = TestApp(BranchWSGIApp(self.branch).app)
-        return app
+        ini = self.config_template%dict(branch=self.bzrbranch)
+
+        config = ConfigObj(ini.splitlines())
+        cherrypy.root = Root(config)
 
     def tearDown(self):
         if self.bzrbranch is not None:
             shutil.rmtree(self.bzrbranch)
         bzrlib.osutils.set_or_unset_env('BZR_HOME', self.old_bzrhome)
 
-
 class TestWithSimpleTree(BasicTests):
 
     def setUp(self):
@@ -79,42 +79,68 @@
         self.msg = 'a very exciting commit message <'
         self.revid = self.tree.commit(message=self.msg)
 
+        self.setUpLoggerhead()
+
+    def test_index(self):
+        testutil.create_request('/')
+        link = '<a href="/project/branch">branch</a>'
+        assert link in cherrypy.response.body[0].lower()
 
     def test_changes(self):
-        app = self.setUpLoggerhead()
-        res = app.get('/changes')
-        res.mustcontain(cgi.escape(self.msg))
+        testutil.create_request('/project/branch/changes')
+        assert cgi.escape(self.msg) in cherrypy.response.body[0]
 
     def test_changes_search(self):
-        app = self.setUpLoggerhead()
-        res = app.get('/changes', params={'q': 'foo'})
-        res.mustcontain('Sorry, no results found for your search.')
+        testutil.create_request('/project/branch/changes?q=foo')
+        assert 'Sorry, no results found for your search.' in cherrypy.response.body[0]
 
     def test_annotate(self):
-        app = self.setUpLoggerhead()
-        res = app.get('/annotate', params={'file_id':self.fileid})
+        testutil.create_request('/project/branch/annotate?'
+                                + 'file_id='+self.fileid)
         for line in self.filecontents.splitlines():
-            res.mustcontain(cgi.escape(line))
+            assert cgi.escape(line) in cherrypy.response.body[0]
 
     def test_inventory(self):
-        app = self.setUpLoggerhead()
-        res = app.get('/files')
-        res.mustcontain('myfilename')
+        testutil.create_request('/project/branch/files')
+        assert 'myfilename' in cherrypy.response.body[0]
 
     def test_revision(self):
-        app = self.setUpLoggerhead()
-        res = app.get('/revision/1')
-        res.mustcontain('myfilename')
+        testutil.create_request('/project/branch/revision/' + self.revid)
+        assert 'myfilename' in cherrypy.response.body[0]
 
+class TestWithSimpleTreeAndCache(TestWithSimpleTree):
+    config_template = """
+    testing = True
+    [project]
+        [[branch]]
+            branch_name = 'branch'
+            folder = '%(branch)s'
+            cachepath = '%(branch)s/cache'
+    """
 
 class TestEmptyBranch(BasicTests):
 
     def setUp(self):
         BasicTests.setUp(self)
         self.createBranch()
+        self.setUpLoggerhead()
+
+    def test_index(self):
+        testutil.create_request('/')
+        link = '<a href="/project/branch">branch</a>'
+        assert link in cherrypy.response.body[0].lower()
 
     def test_changes(self):
-        app = self.setUpLoggerhead()
-        res = app.get('/changes')
-        res.mustcontain('No revisions!')
+        testutil.create_request('/project/branch/changes')
+        assert 'No revisions!' in cherrypy.response.body[0]
+
+class TestEmptyBranchWithCache(TestEmptyBranch):
+    config_template = """
+    testing = True
+    [project]
+        [[branch]]
+            branch_name = 'branch'
+            folder = '%(branch)s'
+            cachepath = '%(branch)s/cache'
+    """
 

=== added file 'loggerhead/textindex.py'
--- loggerhead/textindex.py	1970-01-01 00:00:00 +0000
+++ loggerhead/textindex.py	2008-02-27 03:36:09 +0000
@@ -0,0 +1,240 @@
+#
+# Copyright (C) 2006  Robey Pointer <robey@lag.net>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+"""
+indexing of the comment text of revisions, for fast searching.
+
+two separate database files are created:
+
+    - recorded: revid -> 1 (if the revid is indexed)
+    - index: 3-letter substring -> list(revids)
+"""
+
+import os
+import re
+import time
+
+from loggerhead import util
+from loggerhead.lockfile import LockFile
+from loggerhead.changecache import FakeShelf
+
+# if any substring index reaches this many revids, replace the entry with
+# an ALL marker -- it's not worth an explicit index.
+ALL_THRESHOLD = 1000
+ALL = 'ALL'
+
+
+with_lock = util.with_lock('_lock')
+
+
+def normalize_string(s):
+    """
+    remove any punctuation and normalize all whitespace to a single space.
+    """
+    s = util.to_utf8(s).lower()
+    # remove apostrophes completely.
+    s = re.sub(r"'", '', s)
+    # convert other garbage into space
+    s = re.sub(r'[^\w\d]', ' ', s)
+    # compress multiple spaces into one.
+    s = re.sub(r'\s{2,}', ' ', s)
+    # and finally remove leading/trailing whitespace
+    s = s.strip()
+    return s
+
+
+class TextIndex (object):
+    def __init__(self, history, cache_path):
+        self.history = history
+        self.log = history.log
+
+        if not os.path.exists(cache_path):
+            os.mkdir(cache_path)
+
+        self._recorded_filename = os.path.join(cache_path, 'textindex-recorded.sql')
+        self._index_filename = os.path.join(cache_path, 'textindex.sql')
+
+        # use a lockfile since the cache folder could be shared across different processes.
+        self._lock = LockFile(os.path.join(cache_path, 'index-lock'))
+        self._closed = False
+
+        self.log.info('Using search index; %d entries.', len(self))
+
+    def _index(self):
+        return FakeShelf(self._index_filename)
+
+    def _recorded(self):
+        return FakeShelf(self._recorded_filename)
+
+    def _is_indexed(self, revid, recorded):
+        return recorded.get(util.to_utf8(revid)) is not None
+
+    @with_lock
+    def is_indexed(self, revid):
+        recorded = self._recorded()
+        try:
+            return self._is_indexed(revid, recorded)
+        finally:
+            recorded.close()
+
+    @with_lock
+    def __len__(self):
+        recorded = self._recorded()
+        try:
+            return recorded.count()
+        finally:
+            recorded.close()
+
+    @with_lock
+    def close(self):
+        self._closed = True
+
+    @with_lock
+    def closed(self):
+        return self._closed
+
+    @with_lock
+    def flush(self):
+        pass
+
+    @with_lock
+    def full(self):
+        recorded = self._recorded()
+        last_revid = util.to_utf8(self.history.last_revid)
+        try:
+            return (recorded.count() >= len(self.history.get_revision_history())
+                    and recorded.get(last_revid) is not None)
+        finally:
+            recorded.close()
+
+    def _index_change(self, change, recorded, index):
+        """
+        currently, only indexes the 'comment' field.
+        """
+        comment = normalize_string(change.comment)
+        if len(comment) < 3:
+            return
+        for i in xrange(len(comment) - 2):
+            sub = comment[i:i + 3]
+            orig = revid_set = index.get(sub)
+            if revid_set is None:
+                revid_set = set()
+            elif revid_set == ALL:
+                # this entry got too big
+                continue
+            revid_set.add(change.revid)
+            if len(revid_set) > ALL_THRESHOLD:
+                revid_set = ALL
+            if orig is not None:
+                index.update([(sub, revid_set)], commit=False)
+            else:
+                index.add([(sub, revid_set)], commit=False)
+
+        recorded.add([(util.to_utf8(change.revid), True)], commit=False)
+
+    @with_lock
+    def index_changes(self, revid_list):
+        recorded = self._recorded()
+        index = self._index()
+        try:
+            revid_list = [r for r in revid_list if not self._is_indexed(r, recorded)]
+            change_list = self.history.get_changes(revid_list)
+            for change in change_list:
+                self._index_change(change, recorded, index)
+        finally:
+            index.close(commit=True)
+            recorded.close(commit=True)
+
+    @with_lock
+    def find(self, text, revid_list=None):
+        index = self._index()
+        try:
+            text = normalize_string(text)
+            if len(text) < 3:
+                return []
+
+            total_set = None
+            if revid_list is not None:
+                total_set = set(revid_list)
+            seen_all = False
+
+            for i in xrange(len(text) - 2):
+                sub = text[i:i + 3]
+                revid_set = index.get(sub)
+                if revid_set is None:
+                    # zero matches, stop here.
+                    return []
+                if revid_set == ALL:
+                    # skip
+                    seen_all = True
+                    continue
+                if total_set is None:
+                    total_set = revid_set
+                else:
+                    total_set.intersection_update(revid_set)
+                if len(total_set) == 0:
+                    return []
+        finally:
+            index.close()
+
+        # tricky: if seen_all is True, one of the substring indices was ALL
+        # (in other words, unindexed), so our results are actually a superset
+        # of the exact answer.
+        #
+        # if we cared, we could do a direct match on the result set and cull
+        # out any that aren't actually matches.  for now, i'm gonna say that
+        # we DON'T care, and if one of the substrings hit ALL, there's a small
+        # chance that we'll give a few false positives.
+        return total_set
+
+    def check_rebuild(self, max_time=3600):
+        """
+        check if there are any un-indexed revisions, and if so, index them.
+        but don't spend longer than C{max_time} on it.
+        """
+        if self.closed() or self.full():
+            # all done
+            return
+
+        self.log.info('Building search index...')
+        work = list(self.history.get_revision_history())
+        start_time = time.time()
+        last_update = time.time()
+        count = 0
+
+        jump = 100
+        for i in xrange(0, len(work), jump):
+            r = work[i:i + jump]
+            self.index_changes(r)
+            if self.closed():
+                return
+
+            count += jump
+            now = time.time()
+            if now - start_time > 3600:
+                # there's no point working for hours.  eventually we might even
+                # hit the next re-index interval, which would suck mightily.
+                self.log.info('Search indexing has worked for an hour; giving up for now.')
+                return
+            if now - last_update > 60:
+                self.log.info('Search indexing continues: %d/%d' % (min(count, len(work)), len(work)))
+                last_update = time.time()
+            # give someone else a chance at the lock
+            time.sleep(1)
+        self.log.info('Search index completed.')
+        self.flush()

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2008-07-01 00:10:47 +0000
+++ loggerhead/util.py	2008-06-10 23:00:35 +0000
@@ -27,20 +27,16 @@
 import datetime
 import logging
 import re
+import sha
 import struct
+import sys
 import threading
 import time
+import traceback
 
 
 log = logging.getLogger("loggerhead.controllers")
 
-def fix_year(year):
-    if year < 70:
-        year += 2000
-    if year < 100:
-        year += 1900
-    return year
-
 # Display of times.
 
 # date_day -- just the day
@@ -139,12 +135,28 @@
         return out
 
 
+def clean_revid(revid):
+    if revid == 'missing':
+        return revid
+    return sha.new(revid).hexdigest()
+
+
+def obfuscate(text):
+    return ''.join([ '&#%d;' % ord(c) for c in text ])
+
+
 def trunc(text, limit=10):
     if len(text) <= limit:
         return text
     return text[:limit] + '...'
 
 
+def to_utf8(s):
+    if isinstance(s, unicode):
+        return s.encode('utf-8')
+    return s
+
+
 STANDARD_PATTERN = re.compile(r'^(.*?)\s*<(.*?)>\s*$')
 EMAIL_PATTERN = re.compile(r'[-\w\d\+_!%\.]+@[-\w\d\+_!%\.]+')
 
@@ -168,6 +180,40 @@
     return '%s at %s' % (username, domains[0])
 
 
+def triple_factors(min_value=1):
+    factors = (1, 3)
+    index = 0
+    n = 1
+    while True:
+        if n >= min_value:
+            yield n * factors[index]
+        index += 1
+        if index >= len(factors):
+            index = 0
+            n *= 10
+
+
+def scan_range(pos, max, pagesize=1):
+    """
+    given a position in a maximum range, return a list of negative and positive
+    jump factors for an hgweb-style triple-factor geometric scan.
+
+    for example, with pos=20 and max=500, the range would be:
+    [ -10, -3, -1, 1, 3, 10, 30, 100, 300 ]
+
+    i admit this is a very strange way of jumping through revisions.  i didn't
+    invent it. :)
+    """
+    out = []
+    for n in triple_factors(pagesize + 1):
+        if n > max:
+            return out
+        if pos + n < max:
+            out.append(n)
+        if pos - n >= 0:
+            out.insert(0, -n)
+
+
 # only do this if unicode turns out to be a problem
 #_BADCHARS_RE = re.compile(ur'[\u007f-\uffff]')
 
@@ -213,6 +259,15 @@
     return '-rw-r--r--'
 
 
+def if_present(format, value):
+    """
+    format a value using a format string, if the value exists and is not None.
+    """
+    if value is None:
+        return ''
+    return format % value
+
+
 def b64(s):
     s = base64.encodestring(s).replace('\n', '')
     while (len(s) > 0) and (s[-1] == '='):
@@ -294,25 +349,22 @@
 
     navigation.prev_page_revid = get_offset(-1 * navigation.pagesize)
     navigation.next_page_revid = get_offset(1 * navigation.pagesize)
-    prev_page_revno = navigation.history.get_revno(
-            navigation.prev_page_revid)
-    next_page_revno = navigation.history.get_revno(
-            navigation.next_page_revid)
-    start_revno = navigation.history.get_revno(navigation.start_revid)
 
     params = { 'filter_file_id': navigation.filter_file_id }
     if getattr(navigation, 'query', None) is not None:
         params['q'] = navigation.query
-
-    if getattr(navigation, 'start_revid', None) is not None:
-        params['start_revid'] = start_revno
+    else:
+        params['start_revid'] = navigation.start_revid
 
     if navigation.prev_page_revid:
-        navigation.prev_page_url = navigation.branch.context_url(
-            [navigation.scan_url, prev_page_revno], **params)
+        navigation.prev_page_url = navigation.branch.url([ navigation.scan_url, navigation.prev_page_revid ], **get_context(**params))
     if navigation.next_page_revid:
-        navigation.next_page_url = navigation.branch.context_url(
-            [navigation.scan_url, next_page_revno], **params)
+        navigation.next_page_url = navigation.branch.url([ navigation.scan_url, navigation.next_page_revid ], **get_context(**params))
+
+
+def log_exception(log):
+    for line in ''.join(traceback.format_exception(*sys.exc_info())).split('\n'):
+        log.debug(line)
 
 
 def decorator(unbound):
@@ -345,6 +397,22 @@
 
 
 @decorator
+def strip_whitespace(f):
+    def _f(*a, **kw):
+        out = f(*a, **kw)
+        orig_len = len(out)
+        out = re.sub(r'\n\s+', '\n', out)
+        out = re.sub(r'[ \t]+', ' ', out)
+        out = re.sub(r'\s+\n', '\n', out)
+        new_len = len(out)
+        log.debug('Saved %sB (%d%%) by stripping whitespace.',
+                  human_size(orig_len - new_len),
+                  round(100.0 - float(new_len) * 100.0 / float(orig_len)))
+        return out
+    return _f
+
+
+@decorator
 def lsprof(f):
     def _f(*a, **kw):
         from loggerhead.lsprof import profile
@@ -401,9 +469,6 @@
 
 def get_context(**overrides):
     """
-    Soon to be deprecated.
-
-
     return a context map that may be overriden by specific values passed in,
     but only contains keys from the list of valid context keys.
 

=== removed file 'loggerhead/wholehistory.py'
--- loggerhead/wholehistory.py	2008-07-01 02:24:16 +0000
+++ loggerhead/wholehistory.py	1970-01-01 00:00:00 +0000
@@ -1,63 +0,0 @@
-# Cache the whole history data needed by loggerhead about a branch.
-
-import logging
-import time
-
-from bzrlib.revision import is_null, NULL_REVISION
-from bzrlib.tsort import merge_sort
-
-
-def _strip_NULL_ghosts(revision_graph):
-    """
-    Copied over from bzrlib meant as a temporary workaround for
-    deprecated methods.
-    """
-    # Filter ghosts, and null:
-    if NULL_REVISION in revision_graph:
-        del revision_graph[NULL_REVISION]
-    for key, parents in revision_graph.items():
-        revision_graph[key] = tuple(parent for parent in parents if parent
-            in revision_graph)
-    return revision_graph
-
-
-def compute_whole_history_data(branch):
-    z = time.time()
-
-    last_revid = branch.last_revision()
-
-    log = logging.getLogger('loggerhead.%s' % (branch.nick,))
-
-    graph = branch.repository.get_graph()
-    parent_map = dict(((key, value) for key, value in
-         graph.iter_ancestry([last_revid]) if value is not None))
-
-    _revision_graph = _strip_NULL_ghosts(parent_map)
-    _full_history = []
-    _revision_info = {}
-    _revno_revid = {}
-    if is_null(last_revid):
-        _merge_sort = []
-    else:
-        _merge_sort = merge_sort(
-            _revision_graph, last_revid, generate_revno=True)
-
-    for (seq, revid, merge_depth, revno, end_of_merge) in _merge_sort:
-        _full_history.append(revid)
-        revno_str = '.'.join(str(n) for n in revno)
-        _revno_revid[revno_str] = revid
-        _revision_info[revid] = (
-            seq, revid, merge_depth, revno_str, end_of_merge)
-
-    _where_merged = {}
-
-    for revid in _revision_graph.keys():
-        if _revision_info[revid][2] == 0:
-            continue
-        for parent in _revision_graph[revid]:
-            _where_merged.setdefault(parent, set()).add(revid)
-
-    log.info('built revision graph cache: %r secs' % (time.time() - z,))
-
-    return (_revision_graph, _full_history, _revision_info,
-            _revno_revid, _merge_sort, _where_merged)

=== renamed file 'loggerhead/apps/branch.py' => 'loggerhead/wsgiapp.py'
--- loggerhead/apps/branch.py	2008-07-01 04:01:31 +0000
+++ loggerhead/wsgiapp.py	2008-06-16 08:08:33 +0000
@@ -1,71 +1,47 @@
-"""The WSGI application for serving a Bazaar branch."""
-
 import logging
-import urllib
-
-import bzrlib.branch
-import bzrlib.lru_cache
-
+import os
+
+from paste import urlparser
 from paste import request
 from paste import httpexceptions
+from paste.wsgiwrappers import WSGIRequest, WSGIResponse
 
-from loggerhead.apps import static_app
 from loggerhead.controllers.changelog_ui import ChangeLogUI
 from loggerhead.controllers.inventory_ui import InventoryUI
 from loggerhead.controllers.annotate_ui import AnnotateUI
 from loggerhead.controllers.revision_ui import RevisionUI
 from loggerhead.controllers.atom_ui import AtomUI
 from loggerhead.controllers.download_ui import DownloadUI
-from loggerhead.history import History
-from loggerhead import util
-
+from loggerhead.controllers.bundle_ui import BundleUI
+
+
+static = os.path.join(
+    os.path.dirname(__file__), 'static')
+
+static_app = urlparser.make_static(None, static)
+
+logging.basicConfig()
+logging.getLogger().setLevel(logging.DEBUG)
 
 class BranchWSGIApp(object):
 
-    def __init__(self, branch, friendly_name=None, config={}, graph_cache=None):
-        self.branch = branch
-        self._config = config
-        self.friendly_name = friendly_name
-        self.log = logging.getLogger('loggerhead.%s' % (friendly_name,))
-        if graph_cache is None:
-            graph_cache = bzrlib.lru_cache.LRUCache()
-        self.graph_cache = graph_cache
-
-    def get_history(self):
-        _history = History(self.branch, self.graph_cache)
-        cache_path = self._config.get('cachepath', None)
-        if cache_path is not None:
-            # Only import the cache if we're going to use it.
-            # This makes sqlite optional
-            try:
-                from loggerhead.changecache import FileChangeCache
-            except ImportError:
-                self.log.debug("Couldn't load python-sqlite,"
-                               " continuing without using a cache")
-            else:
-                _history.use_file_cache(
-                    FileChangeCache(_history, cache_path))
-        return _history
+    def __init__(self, history):
+        self.history = history
+        self.friendly_name = 'hello'
+        self.log = logging.getLogger('hi')
 
     def url(self, *args, **kw):
         if isinstance(args[0], list):
             args = args[0]
-        qs = []
+        qs = ''
         for k, v in kw.iteritems():
-            if v is not None:
-                qs.append('%s=%s'%(k, urllib.quote(v)))
-        qs = '&'.join(qs)
+            qs += '%s=%s'%(k, v)
         return request.construct_url(
             self._environ, script_name=self._url_base,
-            path_info='/'.join(args),
+            path_info=self._url_base + '/'.join(args),
             querystring=qs)
 
-    def context_url(self, *args, **kw):
-        kw = util.get_context(**kw)
-        return self.url(*args, **kw)
-
-    def static_url(self, path):
-        return self._static_url_base + path
+    context_url = url
 
     controllers_dict = {
         'annotate': AnnotateUI,
@@ -74,34 +50,24 @@
         'revision': RevisionUI,
         'download': DownloadUI,
         'atom': AtomUI,
+        'bundle': BundleUI,
         }
 
-    def last_updated(self):
-        h = self.get_history()
-        change = h.get_changes([ h.last_revid ])[0]
-        return change.date
-
-    def branch_url(self):
-        return self.branch.get_config().get_user_option('public_branch')
-
     def app(self, environ, start_response):
+        req = WSGIRequest(environ)
+        response = WSGIResponse()
+        response.headers['Content-Type'] = 'text/plain'
         self._url_base = environ['SCRIPT_NAME']
-        self._static_url_base = environ.get('loggerhead.static.url')
-        if self._static_url_base is None:
-            self._static_url_base = self._url_base
         self._environ = environ
         path = request.path_info_pop(environ)
         if not path:
-            raise httpexceptions.HTTPMovedPermanently(
-                self._url_base + '/changes')
+            raise httpexceptions.HTTPMovedPermanently('changes')
         if path == 'static':
             return static_app(environ, start_response)
         cls = self.controllers_dict.get(path)
         if cls is None:
             raise httpexceptions.HTTPNotFound()
-        self.branch.lock_read()
-        try:
-            c = cls(self, self.get_history())
-            return c(environ, start_response)
-        finally:
-            self.branch.unlock()
+        c = cls(self)
+        c.default(req, response)
+        return response(environ, start_response)
+

=== added file 'push-website'
--- push-website	1970-01-01 00:00:00 +0000
+++ push-website	2007-01-24 18:43:51 +0000
@@ -0,0 +1,7 @@
+#!/bin/bash
+#
+# this is only useful for robey.  it updates the public website.
+#
+
+rsync -avr homepage/ robey@green.lag.net:/web/loggerhead
+

=== removed file 'serve-branches.py'
--- serve-branches.py	2008-06-24 23:20:59 +0000
+++ serve-branches.py	1970-01-01 00:00:00 +0000
@@ -1,35 +0,0 @@
-#!/usr/bin/env python
-import logging
-import sys
-
-from paste import httpserver
-from paste.httpexceptions import HTTPExceptionHandler
-from paste.translogger import TransLogger
-
-from loggerhead.apps.filesystem import BranchesFromFileSystemRoot
-
-
-logging.basicConfig()
-logging.getLogger().setLevel(logging.DEBUG)
-
-if len(sys.argv) > 1:
-    path = sys.argv[1]
-else:
-    path = '.'
-
-app = BranchesFromFileSystemRoot(path)
-
-app = HTTPExceptionHandler(app)
-app = TransLogger(app)
-
-try:
-    from paste.deploy.config import PrefixMiddleware
-except ImportError:
-    pass
-else:
-    app = PrefixMiddleware(app)
-
-#from paste.evalexception import EvalException
-#app = EvalException(app)
-
-httpserver.serve(app, host='0.0.0.0', port='8080')

=== modified file 'start-loggerhead.py'
--- start-loggerhead.py	2008-06-30 23:24:32 +0000
+++ start-loggerhead.py	2008-06-11 04:44:45 +0000
@@ -1,20 +1,18 @@
-#!/usr/bin/env python
+#!/usr/bin/env python2.4
+
+import pkg_resources
+pkg_resources.require("TurboGears")
 
 import logging
-import logging.handlers
-from optparse import OptionParser
 import os
 import sys
-import urlparse
-
-from configobj import ConfigObj
-
-from paste import httpserver
-from paste.httpexceptions import make_middleware
-from paste.translogger import make_filter
+from optparse import OptionParser
+
+import turbogears
+import cherrypy
+cherrypy.lowercase_api = True
 
 from loggerhead import daemon, release
-from loggerhead.apps.config import Root
 
 
 def make_handler(config, filename):
@@ -27,14 +25,14 @@
         h = logging.FileHandler(filename)
     return h
 
-
+        
 def setup_logging(home, config, foreground):
     # i hate that stupid logging config format, so just set up logging here.
 
     log_folder = os.path.join(home, 'logs')
     if not os.path.exists(log_folder):
         os.mkdir(log_folder)
-
+    
     f = logging.Formatter('%(levelname)-.3s [%(asctime)s.%(msecs)03d] %(name)s: %(message)s',
                           '%Y%m%d-%H:%M:%S')
     debug_log = make_handler(config, os.path.join(log_folder, 'debug.log'))
@@ -49,14 +47,14 @@
     access_log = make_handler(config, os.path.join(log_folder, 'access.log'))
     access_log.setLevel(logging.INFO)
     access_log.setFormatter(f)
-
-    logging.getLogger('').setLevel(logging.DEBUG)
+    
     logging.getLogger('').addHandler(debug_log)
-    logging.getLogger('wsgi').addHandler(access_log)
-
+    logging.getLogger('turbogears.access').addHandler(access_log)
+    logging.getLogger('turbogears.controllers').setLevel(logging.INFO)
+    
     if foreground:
         logging.getLogger('').addHandler(stdout_log)
-
+    
 
 
 def main():
@@ -68,70 +66,56 @@
     options, args = parser.parse_args()
     if len(args) > 0:
         parser.error('No filename arguments are used, only options.')
-
-
+        
+        
     home = os.path.realpath(os.path.dirname(__file__))
     pidfile = os.path.join(home, 'loggerhead.pid')
-
+    
     if options.check:
         if daemon.is_running(pidfile):
             sys.exit(0)
         sys.stderr.write('Did not find loggerhead running in %r; restarting...\n' % (pidfile,))
-
+    
     # read loggerhead config
-
+    
+    from configobj import ConfigObj
     config = ConfigObj(os.path.join(home, 'loggerhead.conf'), encoding='utf-8')
     extra_path = config.get('bzrpath', None)
     if extra_path:
         sys.path.insert(0, extra_path)
-
-    #turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
-
-    potential_overrides = [ ('server.socket_port', int),
-                            ('server.webpath', str),
-                            ('server.thread_pool', int),
-                            ('server.socket_host' ,str) ]
-    server_port = int(config.get('server.socket_port', 8080))
-    nworkers = int(config.get('server.thread_pool', 10))
-    server_host = config.get('server.socket_host', '0.0.0.0')
-    webpath = config.get('server.webpath', None)
-
+    
+    turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
+    
+    potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int), ('server.socket_host' ,str) ]
     for key, keytype in potential_overrides:
         value = config.get(key, None)
         if value is not None:
             value = keytype(value)
-            #turbogears.config.update({ key: value })
-
+            turbogears.config.update({ key: value })
+    
     if not options.foreground:
         sys.stderr.write('\n')
         sys.stderr.write('Launching loggerhead into the background.\n')
         sys.stderr.write('PID file: %s\n' % (pidfile,))
         sys.stderr.write('\n')
-
+    
         daemon.daemonize(pidfile, home)
 
     setup_logging(home, config, foreground=options.foreground)
-
+        
     log = logging.getLogger('loggerhead')
     log.info('Starting up...')
-
-    app = Root(config)
-
-    app = app
-    app = make_middleware(app)
-    app = make_filter(app, None)
-
-    if webpath:
-        scheme, netloc, path, blah, blah, blah = urlparse.urlparse(webpath)
-        def app(environ, start_response, orig=app):
-            environ['SCRIPT_NAME'] = path
-            environ['HTTP_HOST'] = netloc
-            return orig(environ, start_response)
+    
+    from loggerhead.controllers import Root
+    
+    Root = Root(config)
+    
+    # re-index every 6 hours
+    index_freq = config.get('cache_rebuild_frequency', 6 * 3600)
+    turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
 
     try:
-        httpserver.serve(
-            app, host=server_host, port=server_port,
-            threadpool_workers=nworkers)
+        turbogears.start_server(Root)
     finally:
         log.info('Shutdown.')
         try:

=== modified file 'stop-loggerhead.py'
--- stop-loggerhead.py	2008-06-18 04:30:50 +0000
+++ stop-loggerhead.py	2007-01-24 19:17:25 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/env python
+#!/usr/bin/env python2.4
 
 import pkg_resources
 pkg_resources.require("TurboGears")

=== added directory 'turbosimpletal'
=== added file 'turbosimpletal/__init__.py'
--- turbosimpletal/__init__.py	1970-01-01 00:00:00 +0000
+++ turbosimpletal/__init__.py	2008-06-13 05:33:39 +0000
@@ -0,0 +1,11 @@
+from turbosimpletal import zptsupport
+
+TurboZpt = zptsupport.TurboZpt
+
+__all__ = ["TurboZpt"]
+
+import logging
+simpleTALLogger = logging.getLogger("simpleTAL")
+simpleTALESLogger = logging.getLogger("simpleTALES")
+simpleTALLogger.setLevel(logging.INFO)
+simpleTALESLogger.setLevel(logging.INFO)

=== added directory 'turbosimpletal/tests'
=== added file 'turbosimpletal/tests/__init__.py'
=== renamed file 'loggerhead/tests/simple.pt' => 'turbosimpletal/tests/simple.pt'
=== renamed file 'loggerhead/tests/test_templating.py' => 'turbosimpletal/tests/test_zpt.py'
--- loggerhead/tests/test_templating.py	2008-06-18 06:34:10 +0000
+++ turbosimpletal/tests/test_zpt.py	2008-06-11 03:41:46 +0000
@@ -1,12 +1,26 @@
-from loggerhead.zptsupport import load_template
+from turbosimpletal import TurboZpt
+from turbogears import controllers, expose, testutil
+import cherrypy
 
 RENDERED = u"<html>\n<head>\n<title>%s</title>\n</head>\n<body>\n<div>Hello, %s</div>\n</body>\n</html>"
 
 def test_template_lookup():
-    template = load_template("loggerhead.tests.simple")
+    tc = TurboZpt()
+    template = tc.load_template("turbosimpletal.tests.simple")
     assert template
     TITLE="test"
     NAME="World"
     info = dict(title=TITLE, name=NAME)
     s = template.expand(**info)
     assert s.startswith(RENDERED % (TITLE, NAME))
+
+class TestRoot(controllers.Root):
+    @expose(html="zpt:turbosimpletal.tests.simple")
+    def index(self, name, title="test"):
+        return dict(name=name, title=title)
+
+def test_real_life_situation():
+    cherrypy.root = TestRoot()
+    NAME="Dave"
+    testutil.createRequest("/?name=%s" % NAME)
+    assert cherrypy.response.body[0].startswith(RENDERED % ("test", NAME))

=== renamed file 'loggerhead/zptsupport.py' => 'turbosimpletal/zptsupport.py'
--- loggerhead/zptsupport.py	2008-06-18 06:34:10 +0000
+++ turbosimpletal/zptsupport.py	2008-06-15 06:43:31 +0000
@@ -1,15 +1,11 @@
-"""Support for Zope Page Templates using the simpletal library."""
+"TurboGears support for Zope Page Templates"
 
-import logging
+import StringIO
 import os
 import pkg_resources
-import StringIO
 
 from simpletal import simpleTAL, simpleTALES
 
-logging.getLogger("simpleTAL").setLevel(logging.INFO)
-logging.getLogger("simpleTALES").setLevel(logging.INFO)
-
 
 _zpt_cache = {}
 def zpt(tfile):
@@ -36,7 +32,7 @@
         self.template.expandInline(context, s)
         return s.getvalue()
 
-    def expand_into(self, f, **info):
+    def expand_(self, f, **info):
         context = simpleTALES.Context(allowPythonPath=1)
         for k, v in info.iteritems():
             context.addGlobal(k, v)
@@ -47,20 +43,27 @@
         return self.template.macros
 
 
-def load_template(classname):
-    """Searches for a template along the Python path.
-
-    Template files must end in ".pt" and be in legitimate packages.
-    Templates are automatically checked for changes and reloaded as
-    neccessary.
-    """
-    divider = classname.rfind(".")
-    if divider > -1:
-        package = classname[0:divider]
-        basename = classname[divider+1:]
-    else:
-        raise ValueError, "All templates must be in a package"
-
-    tfile = pkg_resources.resource_filename(
-        package, "%s.%s" % (basename, "pt"))
-    return zpt(tfile)
+class TurboZpt(object):
+    extension = "pt"
+
+    def __init__(self, extra_vars_func=None):
+        self.get_extra_vars = extra_vars_func
+
+    def load_template(self, classname, loadingSite=False):
+        """Searches for a template along the Python path.
+
+        Template files must end in ".pt" and be in legitimate packages.
+        Templates are automatically checked for changes and reloaded as
+        neccessary.
+        """
+        divider = classname.rfind(".")
+        if divider > -1:
+            package = classname[0:divider]
+            basename = classname[divider+1:]
+        else:
+            raise ValueError, "All templates must be in a package"
+
+        tfile = pkg_resources.resource_filename(
+            package, "%s.%s" % (basename, self.extension))
+        return zpt(tfile)
+

=== renamed file 'loggerhead/apps/filesystem.py' => 'wsgitest.py'
--- loggerhead/apps/filesystem.py	2008-07-01 04:01:31 +0000
+++ wsgitest.py	2008-06-13 05:33:39 +0000
@@ -1,91 +1,21 @@
-"""Serve branches at urls that mimic the file system layout."""
-
-import cgi
-import os
-import tempfile
-
-from bzrlib import branch, errors, lru_cache
-
-from paste.request import path_info_pop
-from paste.wsgiwrappers import WSGIRequest, WSGIResponse
-from paste import httpexceptions
-
-from loggerhead.apps.branch import BranchWSGIApp
-from loggerhead.apps import favicon_app, static_app
-
-sql_dir = tempfile.mkdtemp()
-
-
-class DirectoryListing(object):
-
-    def __init__(self, path):
-        self.path = path
-
-    def __call__(self, environ, start_response):
-        request = WSGIRequest(environ)
-        response = WSGIResponse()
-        listing = [d for d in os.listdir(self.path) if not d.startswith('.')]
-        response.headers['Content-Type'] = 'text/html'
-        print >> response, '<html><body>'
-        for d in sorted(listing):
-            if os.path.isdir(os.path.join(self.path, d)):
-                d = cgi.escape(d)
-                print >> response, '<li><a href="%s/">%s</a></li>' % (d, d)
-        print >> response, '</body></html>'
-        return response(environ, start_response)
-
-
-class BranchesFromFileSystemServer(object):
-    def __init__(self, folder, root):
-        self.folder = folder
-        self.root = root
-
-    def app_for_branch(self, branch):
-        if not self.folder:
-            name = os.path.basename(os.path.abspath(self.root.folder))
-        else:
-            name = self.folder
-        branch_app = BranchWSGIApp(
-            branch, name, {'cachepath': sql_dir}, self.root.graph_cache)
-        return branch_app.app
-
-    def app_for_non_branch(self, environ):
-        segment = path_info_pop(environ)
-        if segment is None:
-            raise httpexceptions.HTTPMovedPermanently(
-                environ['SCRIPT_NAME'] + '/')
-        elif segment == '':
-            return DirectoryListing(os.path.join(self.root.folder, self.folder))
-        else:
-            relpath = os.path.join(self.folder, segment)
-            return BranchesFromFileSystemServer(relpath, self.root)
-
-    def __call__(self, environ, start_response):
-        path = os.path.join(self.root.folder, self.folder)
-        if not os.path.isdir(path):
-            raise httpexceptions.HTTPNotFound()
-        try:
-            b = branch.Branch.open(path)
-        except errors.NotBranchError:
-            return self.app_for_non_branch(environ)(environ, start_response)
-        else:
-            return self.app_for_branch(b)(environ, start_response)
-
-
-class BranchesFromFileSystemRoot(object):
-
-    def __init__(self, folder):
-        self.graph_cache = lru_cache.LRUCache()
-        self.folder = folder
-
-    def __call__(self, environ, start_response):
-        environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
-        if environ['PATH_INFO'].startswith('/static/'):
-            segment = path_info_pop(environ)
-            assert segment == 'static'
-            return static_app(environ, start_response)
-        elif environ['PATH_INFO'] == '/favicon.ico':
-            return favicon_app(environ, start_response)
-        else:
-            return BranchesFromFileSystemServer(
-                '', self)(environ, start_response)
+from loggerhead.history import History
+from loggerhead.wsgiapp import BranchWSGIApp
+
+h = History.from_folder('.')
+
+app = BranchWSGIApp(h)
+
+
+from paste import httpserver
+from paste.evalexception import EvalException
+from paste.httpexceptions import make_middleware
+from paste.translogger import make_filter
+
+app = app.app
+for w in EvalException, make_middleware:
+    app = w(app)
+
+app = make_filter(app, None)
+
+httpserver.serve(app, host='127.0.0.1', port='9876')
+

